// AddDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rejig.h"
#include "AddDlg.h"

#ifdef USE_DEBUG_NEW
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddDlg dialog


CAddDlg::CAddDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_nListSize = 0;
}


void CAddDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddDlg)
	DDX_Control(pDX, IDC_FILELIST, m_FileListBox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddDlg, CDialog)
	//{{AFX_MSG_MAP(CAddDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddDlg message handlers

CString CAddDlg::GetFileList()
{
	return m_csFilesCat;
}

CString CAddDlg::GetFirstFile()
{
	return m_csFirstFile;
}

int	CAddDlg::GetListSize()
{
	return m_nListSize;
}

void CAddDlg::AddOtherFiles(CString csRoot)
{
	int nDot = csRoot.ReverseFind('.');
	if ( nDot != -1 )
	{
		// Check that there is a number before the dot
		if ( csRoot[nDot-1] >= '0' && csRoot[nDot-1] <= '9' )
		{
			CString csPrefix, csSuffix;
			if ( nDot-2 >= 0 )
				csPrefix = csRoot.Left(nDot-1);
			int nFileNum = (csRoot[nDot-1] - 48)+1;	// +1 we've added the first file already
			csSuffix = csRoot.Right(csRoot.GetLength()-nDot);

			while ( true )
			{
				CString csFile;
				csFile.Format("%s%d%s", csPrefix, nFileNum++, csSuffix);

				// Check if file exists
				if ( GetFileAttributes(csFile) != -1L )
				{
					m_FileNameList.push_back(csFile);
					m_FileListBox.AddString(m_FileNameList.back());
				}
				else
					break;
			}
		}
	}
}

void CAddDlg::HorizScrollBox()
{
	// Find the longest string in the list box.
	CString str;
	CSize   sz;
	int     dx=0;
	CDC*    pDC = m_FileListBox.GetDC();
	for (int i=0;i < m_FileListBox.GetCount();i++)
	{
	   m_FileListBox.GetText( i, str );
	   sz = pDC->GetTextExtent(str);

	   if (sz.cx > dx)
		  dx = sz.cx;
	}
	m_FileListBox.ReleaseDC(pDC);
	m_FileListBox.SetHorizontalExtent(dx);
}

#define ADD_ALLOWMULTIPLE

void CAddDlg::OnAdd() 
{
	char pszMPGFilterExt[] = "MPEG-2/CCEData Files (*.vob,*.txt,*.ts)|*.vob;*.mpg;*.ts;*.m2v;*.txt|All Files (*.*)|*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, 
#ifdef ADD_ALLOWMULTIPLE
		OFN_ALLOWMULTISELECT |
#endif
		OFN_FILEMUSTEXIST, pszMPGFilterExt, NULL);

	// Added by Nic at the suggestion of mmgrover for Win98 support
	//dlg.m_ofn.lStructSize = OPENFILENAME_SIZE_VERSION_400; 

	if ( dlg.DoModal() == IDOK )
	{
#ifdef ADD_ALLOWMULTIPLE
		POSITION pos = dlg.GetStartPosition();
		
		// Want to load them in the opposite way!
		int nCurrentCount = m_FileListBox.GetCount();

		list<CString> lstSortedList;
		while (pos != NULL)
		{
			lstSortedList.push_front(dlg.GetNextPathName(pos));
		}

		while ( lstSortedList.size() )
		{
			m_FileNameList.push_back(lstSortedList.front());
			m_FileListBox.AddString(lstSortedList.front());

			// on the last one check for more
			if ( lstSortedList.size() == 1 )
				AddOtherFiles(lstSortedList.front());

			lstSortedList.pop_front();
		}

		HorizScrollBox();
#else
		m_FileListBox.AddString(dlg.GetPathName());
		m_FileNameList.push_back(dlg.GetPathName());
		AddOtherFiles(dlg.GetPathName());
#endif
	}
}

void CAddDlg::OnDelete() 
{
	int nCurrent = m_FileListBox.GetCurSel();
	if ( nCurrent != LB_ERR )
	{
		m_FileNameList.erase(&m_FileNameList[nCurrent]);
		m_FileListBox.DeleteString(nCurrent);
		
		int nNewSel = nCurrent >= m_FileListBox.GetCount() ? m_FileListBox.GetCount() : nCurrent;
		m_FileListBox.SetCurSel(nNewSel);
	}
}

void CAddDlg::OnClear() 
{
	m_FileNameList.clear();
	m_FileListBox.ResetContent();
}

void CAddDlg::OnOK() 
{
	if ( m_FileNameList.size() )
	{
		m_nListSize = m_FileNameList.size();
		m_csFirstFile = m_csFilesCat = m_FileNameList.front();
		m_FileNameList.erase(&m_FileNameList.front());

		while ( m_FileNameList.size() )
		{
			m_csFilesCat += " + ";
			m_csFilesCat += m_FileNameList.front();
			m_FileNameList.erase(&m_FileNameList.front());
		}
	}
	CDialog::OnOK();
}

BOOL CAddDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	OnAdd();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
