// AuthorDVDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rejig.h"
#include "AuthorDVDDlg.h"
#include "Authoring.h"
#include "CreateParams.h"

/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/
/////////////////////////////////////////////////////////////////////////////
// CAuthorDVDDlg dialog


CAuthorDVDDlg::CAuthorDVDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAuthorDVDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAuthorDVDDlg)
	m_VideoStream = _T("");
	m_OutputDirectory = _T("");
	m_csAudioDelay = _T("0");
	m_csOrigIFO = _T("");
	m_nOrigPGC = 0;
	//}}AFX_DATA_INIT
	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hStop = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_hBusy = CreateEvent(NULL, TRUE, TRUE, NULL);
	bAutoRun = false;
	bIsPal = true;
}


static struct
{
	char descr[3];
	char lang_long[20];
} LangTable[] = {
/* The ISO 639 language codes.
	*/
	{"  ", "Not Specified"},
	{"aa", "Afar"},
	{"ab", "Abkhazian"},
	{"af", "Afrikaans"},
	{"am", "Amharic"},
	{"ar", "Arabic"},
	{"as", "Assamese"},
	{"ay", "Aymara"},
	{"az", "Azerbaijani"},
	{"ba", "Bashkir"},
	{"be", "Byelorussian"},
	{"bg", "Bulgarian"},
	{"bh", "Bihari"},
	{"bi", "Bislama"},
	{"bn", "Bengali; Bangla"},
	{"bo", "Tibetan"},
	{"br", "Breton"},
	{"ca", "Catalan"},
	{"co", "Corsican"},
	{"cs", "Czech(Ceske)"},
	{"cy", "Welsh"},
	{"da", "Dansk"},
	{"de", "Deutsch"},
	{"dz", "Bhutani"},
	{"el", "Greek"},
	{"en", "English"},
	{"eo", "Esperanto"},
	{"es", "Espanol"},
	{"et", "Estonian"},
	{"eu", "Basque"},
	{"fa", "Persian"},
	{"fi", "Suomi"},
	{"fj", "Fiji"},
	{"fo", "Faroese"},
	{"fr", "Francais"},
	{"fy", "Frisian"},
	{"ga", "Irish"},
	{"gd", "Scots Gaelic"},
	{"gl", "Galician"},
	{"gn", "Guarani"},
	{"gu", "Gujarati"},
	{"ha", "Hausa"},
	{"he", "Hebrew"},				// formerly iw
	{"hi", "Hindi"},
	{"hr", "Hrvatski"},				// Croatian
	{"hu", "Magyar"},
	{"hy", "Armenian"},
	{"ia", "Interlingua"},
	{"id", "Indonesian"},				// formerly in
	{"ie", "Interlingue"},
	{"ik", "Inupiak"},
	{"in", "Indonesian"},				// replaced by id
	{"is", "Islenska"},
	{"it", "Italiano"},
	{"iu", "Inuktitut"},
	{"iw", "Hebrew"},				// replaced by he
	{"ja", "Japanese"},
	{"ji", "Yiddish"},				// replaced by yi
	{"jw", "Javanese"},
	{"ka", "Georgian"},
	{"kk", "Kazakh"},
	{"kl", "Greenlandic"},
	{"km", "Cambodian"},
	{"kn", "Kannada"},
	{"ko", "Korean"},
	{"ks", "Kashmiri"},
	{"ku", "Kurdish"},
	{"ky", "Kirghiz"},
	{"la", "Latin"},
	{"ln", "Lingala"},
	{"lo", "Laothian"},
	{"lt", "Lithuanian"},
	{"lv", "Latvian, Lettish"},
	{"mg", "Malagasy"},
	{"mi", "Maori"},
	{"mk", "Macedonian"},
	{"ml", "Malayalam"},
	{"mn", "Mongolian"},
	{"mo", "Moldavian"},
	{"mr", "Marathi"},
	{"ms", "Malay"},
	{"mt", "Maltese"},
	{"my", "Burmese"},
	{"na", "Nauru"},
	{"ne", "Nepali"},
	{"nl", "Nederlands"},
	{"no", "Norsk"},
	{"oc", "Occitan"},
	{"om", "(Afan) Oromo"},
	{"or", "Oriya"},
	{"pa", "Punjabi"},
	{"pl", "Polish"},
	{"ps", "Pashto, Pushto"},
	{"pt", "Portugues"},
	{"qu", "Quechua"},
	{"rm", "Rhaeto-Romance"},
	{"rn", "Kirundi"},
	{"ro", "Romanian"},
	{"ru", "Russian"},
	{"rw", "Kinyarwanda"},
	{"sa", "Sanskrit"},
	{"sd", "Sindhi"},
	{"sg", "Sangho"},
	{"sh", "Serbo-Croatian"},
	{"si", "Sinhalese"},
	{"sk", "Slovak"},
	{"sl", "Slovenian"},
	{"sm", "Samoan"},
	{"sn", "Shona"},
	{"so", "Somali"},
	{"sq", "Albanian"},
	{"sr", "Serbian"},
	{"ss", "Siswati"},
	{"st", "Sesotho"},
	{"su", "Sundanese"},
	{"sv", "Svenska"},
	{"sw", "Swahili"},
	{"ta", "Tamil"},
	{"te", "Telugu"},
	{"tg", "Tajik"},
	{"th", "Thai"},
	{"ti", "Tigrinya"},
	{"tk", "Turkmen"},
	{"tl", "Tagalog"},
	{"tn", "Setswana"},
	{"to", "Tonga"},
	{"tr", "Turkish"},
	{"ts", "Tsonga"},
	{"tt", "Tatar"},
	{"tw", "Twi"},
	{"ug", "Uighur"},
	{"uk", "Ukrainian"},
	{"ur", "Urdu"},
	{"uz", "Uzbek"},
	{"vi", "Vietnamese"},
	{"vo", "Volapuk"},
	{"wo", "Wolof"},
	{"xh", "Xhosa"},
	{"yi", "Yiddish"},				// formerly ji
	{"yo", "Yoruba"},
	{"za", "Zhuang"},
	{"zh", "Chinese"},
	{"zu", "Zulu"},
	{"\0", "???"}
};

void CAuthorDVDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAuthorDVDDlg)
	DDX_Control(pDX, IDC_VIDTYPE, m_VidType);
	DDX_Control(pDX, IDC_CHAPTERPOS, m_ChapterLst);
	DDX_Control(pDX, IDC_AUDIOLANGCOMBO, m_AudioLangLst);
	DDX_Control(pDX, IDC_SUBLANGCOMBO, m_SubLangLst);
	DDX_Control(pDX, IDC_SUBLST, m_SubLst);
	DDX_Control(pDX, IDC_AUDIOLST, m_AudioLst);
	DDX_Control(pDX, IDC_PROGRESSBAR, m_ProgressBar);
	DDX_Text(pDX, IDC_VIDEOSTRM, m_VideoStream);
	DDX_Text(pDX, IDC_DESTDIRECTORY, m_OutputDirectory);
	DDX_Text(pDX, IDC_AUDIODELAY, m_csAudioDelay);
	DDX_Text(pDX, IDC_ORIGIFO, m_csOrigIFO);
	DDX_Text(pDX, IDC_ORIGPGC, m_nOrigPGC);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAuthorDVDDlg, CDialog)
	//{{AFX_MSG_MAP(CAuthorDVDDlg)
	ON_BN_CLICKED(IDC_VIDBROWSE, OnVidBrowse)
	ON_BN_CLICKED(IDC_AUDIOBROWSE, OnAudioBrowse)
	ON_BN_CLICKED(IDC_SUBBROWSE, OnSubBrowse)
	ON_LBN_SELCHANGE(IDC_AUDIOLST, OnSelChangeAudiolst)
	ON_LBN_SELCHANGE(IDC_SUBLST, OnSelChangeSublst)
	ON_CBN_SELCHANGE(IDC_AUDIOLANGCOMBO, OnSelChangeAudioLang)
	ON_CBN_SELCHANGE(IDC_SUBLANGCOMBO, OnSelChangeSubLang)
	ON_BN_CLICKED(IDC_CHAPBROWSE, OnChapBrowse)
	ON_BN_CLICKED(IDC_DESTBROWSE, OnDestBrowse)
	ON_BN_CLICKED(IDC_STOPMUX, OnStop)
	ON_BN_CLICKED(IDC_ORIGIFOBROWSE, OnOrigIFObrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAuthorDVDDlg message handlers

void CAuthorDVDDlg::OnVidBrowse() 
{
	UpdateData(TRUE);

	CFileDialog dlg(TRUE, "m2v", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "M2V Files (*.m2v)|*.m2v|All Files (*.*)|*.*||");
	if ( dlg.DoModal() == IDOK )
	{
		m_VideoStream = dlg.GetPathName();
	}

	UpdateData(FALSE);
}

void CAuthorDVDDlg::OnAudioBrowse() 
{
	UpdateData(TRUE);

	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Audio Files (*.ac3,*.mpa,*.dts,*.wav)|*.ac3;*.mpa;*.dts;*.wav|All Files (*.*)|*.*||");
	if ( dlg.DoModal() == IDOK )
	{
		CStream stream;
		stream.csFileName = dlg.GetPathName();
		stream.nLangIdx = m_AudioLangLst.GetCurSel();		
		vecAudioStreams.push_back(stream);
		m_AudioLst.AddString(dlg.GetPathName());
		m_AudioLst.SetCurSel(m_AudioLst.GetCount()-1);
	}

	UpdateData(FALSE);
}

void CAuthorDVDDlg::OnSubBrowse() 
{
	UpdateData(TRUE);

	CFileDialog dlg(TRUE, "sup", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "SUP Files (*.sup)|*.sup|All Files (*.*)|*.*||");
	if ( dlg.DoModal() == IDOK )
	{
		CStream stream;
		stream.csFileName = dlg.GetPathName();
		stream.nLangIdx = m_SubLangLst.GetCurSel();		
		vecSubStreams.push_back(stream);
		m_SubLst.AddString(dlg.GetPathName());
		m_SubLst.SetCurSel(m_SubLst.GetCount()-1);
	}

	UpdateData(FALSE);
}

BOOL CAuthorDVDDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ModifyStyleEx(0,WS_EX_APPWINDOW);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	int i = 0;
	while ( true )
	{
		if ( LangTable[i].descr[0] == 0 )
			break;
		m_SubLangLst.AddString(LangTable[i].lang_long);
		m_AudioLangLst.AddString(LangTable[i].lang_long);
		i++;
	}
	
	m_VidType.AddString("PAL");
	m_VidType.AddString("NTSC");

	if ( bIsPal )
		m_VidType.SetCurSel(0);
	else
		m_VidType.SetCurSel(1);

	ReDraw();

	if ( !csChapFile.IsEmpty() )
	{
		FILE *fin = fopen(csChapFile, "rt");
		if ( fin )
		{
			while ( true )
			{
				char szText[100];
				if ( fscanf(fin, "%s\n", szText) == EOF )
					break;
				m_ChapterLst.AddString(szText);
			}
			fclose(fin);
		}
	}

	if ( bAutoRun )
	{
		DWORD dwThreadID;
		CreateThread(NULL, 0, ThreadProc, this, 0, &dwThreadID);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

DWORD WINAPI CAuthorDVDDlg::ThreadProc(LPVOID lpParameter)
{
	CAuthorDVDDlg *This = (CAuthorDVDDlg *)lpParameter;
	Sleep(200);
	This->SendMessage(WM_COMMAND, IDOK);
	return 0;
}

void CAuthorDVDDlg::ReDraw()
{
	UpdateData();

	int i;
	int nAudioSel = m_AudioLst.GetCurSel();
	int nSubSel = m_SubLst.GetCurSel();

	m_AudioLst.ResetContent();	
	m_SubLst.ResetContent();	


	for ( i = 0; i != vecAudioStreams.size(); i++ )
		m_AudioLst.AddString(vecAudioStreams[i].csFileName);
	for ( i = 0; i != vecSubStreams.size(); i++ )
		m_SubLst.AddString(vecSubStreams[i].csFileName);

	if ( nAudioSel < 0 )
		nAudioSel = 0;

	if ( nSubSel < 0 )
		nSubSel = 0;

	m_AudioLst.SetCurSel(nAudioSel);
	m_SubLst.SetCurSel(nSubSel);

	if ( vecAudioStreams.size() )
		m_AudioLangLst.SetCurSel(vecAudioStreams[m_AudioLst.GetCurSel()].nLangIdx);
	else
		m_AudioLangLst.SetCurSel(25);

	if ( vecSubStreams.size() )
		m_SubLangLst.SetCurSel(vecSubStreams[m_SubLst.GetCurSel()].nLangIdx);
	else
		m_SubLangLst.SetCurSel(25);
}

void CAuthorDVDDlg::OnSelChangeAudiolst() 
{
	ReDraw();	
}

void CAuthorDVDDlg::OnSelChangeSublst() 
{
	ReDraw();	
}

void CAuthorDVDDlg::OnSelChangeAudioLang() 
{
	if ( m_AudioLst.GetCount() > 0 )
		vecAudioStreams[m_AudioLst.GetCurSel()].nLangIdx = m_AudioLangLst.GetCurSel();
}

void CAuthorDVDDlg::OnSelChangeSubLang() 
{
	if ( m_SubLst.GetCount() > 0 )
		vecSubStreams[m_SubLst.GetCurSel()].nLangIdx = m_SubLangLst.GetCurSel();
}

void CAuthorDVDDlg::OnChapBrowse() 
{
	UpdateData(TRUE);

	CFileDialog dlg(TRUE, "txt", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Chapter Files (*.txt)|*.txt|All Files (*.*)|*.*||");
	if ( dlg.DoModal() == IDOK )
	{
		FILE *fin = fopen(dlg.GetPathName(), "rt");
		if ( fin )
		{
			while ( true )
			{
				char szText[100];
				if ( fscanf(fin, "%s\n", szText) == EOF )
					break;
				m_ChapterLst.AddString(szText);
			}
			fclose(fin);
		}
	}
}

void CAuthorDVDDlg::OnDestBrowse() 
{
	#ifndef BIF_NEWDIALOGSTYLE
	#define BIF_NEWDIALOGSTYLE	0x0040
	#define BIF_USENEWUI (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
	#endif
	
	if ( !UpdateData(TRUE) )
		return;

	BROWSEINFO BrowseInfo;
	char	   szPath[MAX_PATH];

	BrowseInfo.hwndOwner = this->m_hWnd;
	BrowseInfo.pidlRoot = NULL;
	BrowseInfo.pszDisplayName = szPath;
	BrowseInfo.lpszTitle = NULL;
	BrowseInfo.ulFlags = BIF_USENEWUI;
	BrowseInfo.lpfn = NULL;
	BrowseInfo.lParam = 0;
	BrowseInfo.iImage = 0;
	LPITEMIDLIST lpItemIDList = SHBrowseForFolder(&BrowseInfo);

	if ( lpItemIDList )
	{
		char szBuffer[MAX_PATH];
		if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
		{
			// At this point, szBuffer contains the path 
			// the user chose.
			if (szBuffer[0] == '\0')
			{
			   // SHGetPathFromIDList failed, or
			   // SHBrowseForFolder failed.
			   AfxMessageBox("Failed to get Directory",
				  MB_ICONSTOP|MB_OK);
			   return;
			}
		}

		m_OutputDirectory = szBuffer;
		UpdateData(FALSE);
	}	
}

void CAuthorDVDDlg::SetActionText(CString csAction)
{
	GetDlgItem(IDC_TEXTOUT)->SetWindowText(csAction);
}

// bEnable is false when we want to get busy
void CAuthorDVDDlg::ButtonControl(bool bEnable)
{
	if ( bEnable )
	{
		SetActionText("");
		m_ProgressBar.SetPos(0);
		SetEvent(m_hBusy);
	}
	else
	{
		ResetEvent(m_hBusy);
		ResetEvent(m_hStop);
	}

	GetDlgItem(IDC_VIDEOSTRM)->EnableWindow(bEnable);
	GetDlgItem(IDC_VIDBROWSE)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUDIOLST)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUDIOBROWSE)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUDIOLANGCOMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUDIODELAY)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUDIOBROWSE)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUDIOLST)->EnableWindow(bEnable);
	GetDlgItem(IDC_SUBLST)->EnableWindow(bEnable);
	GetDlgItem(IDC_SUBBROWSE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SUBLANGCOMBO)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHAPTERPOS)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHAPBROWSE)->EnableWindow(bEnable);
	GetDlgItem(IDC_VIDTYPE)->EnableWindow(bEnable);
	GetDlgItem(IDC_DESTBROWSE)->EnableWindow(bEnable);
	GetDlgItem(IDC_DESTDIRECTORY)->EnableWindow(bEnable);
	GetDlgItem(IDOK)->EnableWindow(bEnable);
	GetDlgItem(IDC_STOPMUX)->EnableWindow(!bEnable);
}

void CAuthorDVDDlg::OnOK() 
{
	UpdateData();

	ResetEvent(m_hStop);

	if ( GetFileAttributes(m_OutputDirectory) == -1L )
	{
		// If the Directory does not exist Create it
		CreateDirectory(m_OutputDirectory, NULL);
		if ( GetFileAttributes(m_OutputDirectory) == -1L )
		{
			MessageBox("Directory does not exist!", "Output Error", MB_ICONEXCLAMATION | MB_OK);
			return;
		}
	}

	if ( m_VideoStream == "" || GetFileAttributes(m_VideoStream) == -1L )
	{
		MessageBox("M2V Doesn't Exist!", "Output Error", MB_ICONEXCLAMATION | MB_OK);
		return;
	}

	int i;
	CString csMuxOut = m_OutputDirectory + "\\Mux.vob";

	CCreateParams MuxParams;

	MuxParams.AddParams("-f");
	MuxParams.AddParams("8");
	MuxParams.AddParams("-o");
	MuxParams.AddParams(csMuxOut);
	MuxParams.AddParams("-O");
	MuxParams.AddParams(m_csAudioDelay);

	// Video Params
	MuxParams.AddParams(m_VideoStream);

	for ( i = 0; i != vecAudioStreams.size(); i++ )
	{
		MuxParams.AddParams(vecAudioStreams[i].csFileName);
	}

	ButtonControl(false);
	SetActionText("Multiplexing...");
	MuxParams.OutputToDebug();
	MPlex(MuxParams.GetArgc(), MuxParams.GetArgv(), m_ProgressBar.GetSafeHwnd(), this, m_hStop);

	// Sup Mux
	if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT && vecSubStreams.size() )
	{
		CString csSupMuxOut = m_OutputDirectory + "\\SupMuxed.vob";
		CCreateParams SupMuxParams;
		SupMuxParams.AddParams(csMuxOut);
		SupMuxParams.AddParams(csSupMuxOut);

		int nSubStream = 0x20;
		for ( i = 0; i != vecSubStreams.size(); i++ )
		{
			char szText[50];
			sprintf(szText, "0x%X", nSubStream);
			SupMuxParams.AddParams(vecSubStreams[i].csFileName);
			SupMuxParams.AddParams(szText);
			nSubStream++;
		}

		SetActionText("Multiplexing Subtitles...");
		SupMux(SupMuxParams.GetArgc(), SupMuxParams.GetArgv(), m_ProgressBar.GetSafeHwnd(), this, m_hStop);
		
		if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			// Delete the NonSubbed VOB && Sups
			DeleteFile(csMuxOut);
			csMuxOut = csSupMuxOut;
		}
	}

	// IFOGen
	if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
	{
		CString csDVDDir = m_OutputDirectory;
		if ( !csDVDDirExt.IsEmpty() )
		{
			csDVDDir += (CString("\\") + csDVDDirExt);
		}
		CreateDirectory(csDVDDir, NULL);

		CCreateParams IFOMuxParams;
		IFOMuxParams.AddParams("-o");
		IFOMuxParams.AddParams(csDVDDir);

		// Do audio languages
		CString csAudioLang;
		for ( i = 0; i != vecAudioStreams.size(); i++ )
		{
			csAudioLang += LangTable[vecAudioStreams[i].nLangIdx].descr;
			csAudioLang += ",";
		}
		
		if ( csAudioLang.GetLength() )
		{
			if ( csAudioLang[csAudioLang.GetLength()-1] == ',' )
				csAudioLang = csAudioLang.Left(csAudioLang.GetLength()-1);
			IFOMuxParams.AddParams("-a");
			IFOMuxParams.AddParams(csAudioLang);
		}

		// Do sub languages
		CString csSubLang;
		for ( i = 0; i != vecSubStreams.size(); i++ )
		{
			csSubLang += LangTable[vecSubStreams[i].nLangIdx].descr;
			csSubLang += ",";
		}

		if ( csSubLang.GetLength() )
		{
			if ( csSubLang[csSubLang.GetLength()-1] == ',' )
				csSubLang = csSubLang.Left(csSubLang.GetLength()-1);
			IFOMuxParams.AddParams("-s");
			IFOMuxParams.AddParams(csSubLang);
		}

		// Do Chapters
		double fps;
		switch ( m_VidType.GetCurSel() )
		{
		case 0:
			fps = 25.0;
			break;
		case 1:
			fps = 30000.0/1001.0;
			break;
		}

		CString csChapters;
		for ( i = 0; i != m_ChapterLst.GetCount(); i++ )
		{
			CString csFrameNum;
			m_ChapterLst.GetText(i, csFrameNum);
			double fFrameNo = atof(csFrameNum);
			double fSecs = fFrameNo / fps;

			CString csChap;
			csChap.Format("%02u:%02u:%02u,", ((int)fSecs/3600), ((int)fSecs%3600)/60, ((int)(fSecs+0.5))%60);
			csChapters += csChap;
		}

		if ( csChapters.GetLength() )
		{
			if ( csChapters[csChapters.GetLength()-1] == ',' )
				csSubLang = csChapters.Left(csChapters.GetLength()-1);
			IFOMuxParams.AddParams("-c");
			IFOMuxParams.AddParams(csChapters);
		}

		// Input Vob
		IFOMuxParams.AddParams("-f");
		IFOMuxParams.AddParams(csMuxOut);

		IFOMuxParams.OutputToDebug();
		SetActionText("Create DVD Files...");
		IFOGen(IFOMuxParams.GetArgc(), IFOMuxParams.GetArgv(), m_ProgressBar.GetSafeHwnd(), this, m_hStop);

		// Remove VOB
		DeleteFile(csMuxOut);

		if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			// Now make VIDEO_TS
			IFOMuxParams.Clear();
			IFOMuxParams.AddParams("-T");
			IFOMuxParams.AddParams("-o");
			IFOMuxParams.AddParams(csDVDDir);

			SetActionText("Create DVD Structure...");
			IFOGen(IFOMuxParams.GetArgc(), IFOMuxParams.GetArgv(), m_ProgressBar.GetSafeHwnd(), this, m_hStop);
		}

		// Do a CLUT copy if we can
		if ( !m_csOrigIFO.IsEmpty() )
		{
			ClutCopy(m_csOrigIFO, m_nOrigPGC, csDVDDir+CString("\\VIDEO_TS\\VTS_01_0.IFO"), 0);
		}
	}

	ButtonControl(true);

	if ( bAutoRun )
		OnCancel();
}

void CAuthorDVDDlg::OnCancel() 
{
	SetEvent(m_hStop);
	WaitForSingleObject(m_hBusy, INFINITE);

	CloseHandle(m_hStop);	
	CloseHandle(m_hBusy);	
	CDialog::OnCancel();
}

void CAuthorDVDDlg::OnStop() 
{
	SetEvent(m_hStop);
}

void CAuthorDVDDlg::OnOrigIFObrowse() 
{
	if ( !UpdateData(TRUE) )
		return;	

	CFileDialog dlg(TRUE, "ifo", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "IFO Files (*.ifo)|*.ifo|All Files (*.*)|*.*||");
	if ( dlg.DoModal() == IDOK )
	{
		m_csOrigIFO = dlg.GetPathName();
	}	

	UpdateData(FALSE);
}
