
#ifndef __CDEMUX_H__
#define __CDEMUX_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <io.h>

#define OUTBUFFERSIZE 10000000

#define DEMUX_PROGRAM_END_CODE 0

#define DEMUX_FAIL    -2
#define DEMUX_UNKNOWN -1
#define DEMUX_PS	   0
#define DEMUX_TS  	   1
#define DEMUX_ES	   2

#define DEMUX_HEADER 0
#define DEMUX_DATA 1
#define DEMUX_SKIP 2

class CDemux
{
public:
	CDemux(bool bTS = false, int stream_or_pid = 0xe0, int sub_stream = 0);
	~CDemux();

	static int TestStream(unsigned char *buf, int bufsize, bool *mpeg2 = NULL);
	static int TestFile(const char *szFileName, bool *mpeg2 = NULL);
	static int OldTestStream(unsigned char *buf, int bufsize);
	
	int PS_Load(unsigned char *buf, int bufsize);
	int TS_Load(unsigned char *in_buf, int bytes);
	int Load(unsigned char *buf, int bufsize);
	
	void Reset();

	unsigned char *GetPtr()		 { return m_OutBuf; };

	unsigned int       GetPTS()		 { return m_PTS; };
	unsigned int	   GetFirstPTS() { return m_FirstPTS; };
	unsigned __int64   GetBigPTS()		 { return m_BigPTS; };
	unsigned __int64   GetBigFirstPTS() { return m_BigFirstPTS; };

private:
	// Main workhorse code
	int demux (unsigned char * buf, unsigned char * end, int flags);
	
	void write_buf(unsigned char *buf, int size);	// Writes to the outbuffer, used by demux

	unsigned int m_PTS;
	unsigned int m_FirstPTS;

	unsigned __int64 m_BigPTS;
	unsigned __int64 m_BigFirstPTS;

	int m_demux_track;
	int m_sub_stream;
	int m_demux_pid; 

    int state;
    int state_bytes;
    unsigned char head_buf[264];


	unsigned char *m_OutPtrEnd;
	unsigned char *m_OutBuf;

	bool m_bES;		// ES Stream, No Demuxing Needs to be done!

	unsigned int Get_Bits(unsigned int N);
	DWORD CurrentBfr, BitsLeft;
};


#endif