
#include "FileProperties.h"

bool CFileProperties::GetInfoFromFile(LPCSTR szFileName)
{
	bool bRet = false;

	// First get the stream type
	nFileType = CDemux::TestFile(szFileName);
	int i;

	FILE *f = fopen(szFileName, "rb");
	if ( !f )
		return false;

	BYTE *readbuf = new BYTE[PROPERTIES_BUFFER];
	int nBuffer = fread(readbuf, 1, PROPERTIES_BUFFER, f);
	fclose(f);

	// Remove old streams from list
	m_Streams.clear();

	CDemux VideoDemux(false, 0xe0);

	switch ( nFileType )
	{
	// Elementry Stream, No other streams.
	case DEMUX_ES:	
		bRet = true;
		break;
	
	// Program Stream
	case DEMUX_PS:
		// Bit of a sh*t way of doing it, needs re-writing

		// Cycle through Video streams
		for ( i = 0xe0; i != 0xe8; i++ )
		{
			CDemux demux(false, i);
			int nDemuxed = demux.PS_Load(readbuf, nBuffer);
			if ( nDemuxed > 0)
			{
				CStreamInfo StreamInfo;
				StreamInfo.nStreamNo = i;
				StreamInfo.stStreamType = STREAM_M2V;
				m_Streams.push_back(StreamInfo);
			}
		}

		// Cycle through AC3 audio streams
		for ( i = 0x80; i != 0x88; i++ )
		{
			CDemux demux(false, 0xbd, i);
			int nDemuxed = demux.PS_Load(readbuf, nBuffer);
			if ( nDemuxed > 0)
			{
				CStreamInfo StreamInfo;
				StreamInfo.nStreamNo = 0xbd;
				StreamInfo.nSubStream = i;
				StreamInfo.stStreamType = STREAM_AC3;
				GetAudioDelay(szFileName, 0, &StreamInfo.nAudioDelay, 0xbd, i);
				m_Streams.push_back(StreamInfo);
			}

		}

		// Cycle through MPA audio streams
		for ( i = 0xc0; i != 0xc8; i++ )
		{
			CDemux demux(false, i);
			int nDemuxed = demux.PS_Load(readbuf, nBuffer);
			if ( nDemuxed > 0)
			{
				CStreamInfo StreamInfo;
				StreamInfo.nStreamNo = i;
				StreamInfo.stStreamType = STREAM_MPA;
				GetAudioDelay(szFileName, 0, &StreamInfo.nAudioDelay, i);
				m_Streams.push_back(StreamInfo);
			}
		}

		// Cycle through LPCM audio streams
		for ( i = 0xa0; i != 0xa8; i++ )
		{
			CDemux demux(false, 0xbd, i);
			int nDemuxed = demux.PS_Load(readbuf, nBuffer);
			if ( nDemuxed > 0)
			{
				CStreamInfo StreamInfo;
				StreamInfo.nStreamNo = 0xbd;
				StreamInfo.nSubStream = i;
				StreamInfo.stStreamType = STREAM_LPCM;
				GetAudioDelay(szFileName, 0, &StreamInfo.nAudioDelay, 0xbd, i);
				m_Streams.push_back(StreamInfo);
			}
		}

		// Cycle through DTS audio streams
		for ( i = 0x89; i != 0x89+8; i++ )
		{
			CDemux demux(false, 0xbd, i);
			int nDemuxed = demux.PS_Load(readbuf, nBuffer);
			if ( nDemuxed > 0)
			{
				CStreamInfo StreamInfo;
				StreamInfo.nStreamNo = 0xbd;
				StreamInfo.nSubStream = i;
				StreamInfo.stStreamType = STREAM_DTS;
				GetAudioDelay(szFileName, 0, &StreamInfo.nAudioDelay, 0xbd, i);
				m_Streams.push_back(StreamInfo);
			}
		}
/*
		// Cycle through Sub streams!
		for ( i = 0x20; i != 0x40; i++ )
		{
			CDemux demux(false, 0xbd, i);
			int nDemuxed = demux.PS_Load(readbuf, nBuffer);
			if ( nDemuxed > 0)
			{
				CStreamInfo StreamInfo;
				StreamInfo.nStreamNo = 0xbd;
				StreamInfo.nSubStream = i;
				StreamInfo.stStreamType = STREAM_SUB;
				GetAudioDelay(szFileName, 0, &StreamInfo.nAudioDelay, 0xbd, i);
				m_Streams.push_back(StreamInfo);
			}
		}
*/
		bRet = true;
		break;

	// Transport Stream
	case DEMUX_TS:
		CPATParser PATParser;
		int PMID;
		PMID = PATParser.GetFirstPMID(szFileName);
		CPMSParser PMSParser;
		PMSParser.GetPIDs(szFileName, PMID, &m_Streams);
		bRet = true;
		break;
	}

	delete [] readbuf;

	return bRet;
}


bool CFileProperties::GetAudioDelay(const char *szPath, __int64 nSeekTo, int *delay, int stream, int substream)
{
	unsigned char readbuf[PTS_READBUF*2];

	bool mpeg1 = false;
	
	CurrentBfr = 0;
	BitsLeft = 0;

	// load file
	int in = open(szPath, _O_RDONLY | _O_BINARY );
	if ( in == -1 )
		return false;

	read(in, readbuf, PTS_READBUF*2);
//	CDemux::TestStream(readbuf, PTS_READBUF*2, &mpeg1);
//	mpeg1 = !mpeg1;
	_lseeki64(in, nSeekTo, SEEK_SET);

	int maxtoread = 0;

	int j = 0;

	// Find video header
	bool bFoundVideoPTS = false;
	__int64 Video_PTS, Audio_PTS;

	while ( read(in, readbuf, PTS_READBUF) == PTS_READBUF )
	{
		maxtoread += PTS_READBUF;
		
		for ( int i = 0; i != PTS_READBUF-20; i++ )
		{
			if ( SWAP32(*((DWORD*)&readbuf[i])) >= 0x000001e0 && SWAP32(*((DWORD*)&readbuf[i])) <= 0x000001e7)
			{
				int PTS_DTS_Flags = 0;
				
				if ( mpeg1 )
				{
					i+=6;
					while ( readbuf[i] & 0x80 )
						i++;
					i+=2;

					CurrentBfr = ( readbuf[i] << 24 ) |
								 ( readbuf[i+1] << 16 ) |
								 ( readbuf[i+2] << 8  ) |
								 ( readbuf[i+3] );
					BitsLeft   = 32;
					PTS_DTS_Flags = Get_Bits(4);
					__int64 PTS_32, PTS_29, PTS_14;
					PTS_32 = Get_Bits(3);
					BitsLeft--;
					PTS_29 = Get_Bits(15);
					BitsLeft--;
					CurrentBfr = ( readbuf[i+3] << 24 ) |
								 ( readbuf[i+4] << 16 ) |
								 ( readbuf[i+5] << 8  ) |
								 ( readbuf[i+6] );
					BitsLeft   = 32;
					PTS_14 = Get_Bits(15);
					Video_PTS = PTS_32 << 30; 
					Video_PTS |= ( PTS_29 << 15 ); 
					Video_PTS |= PTS_14; 
					Video_PTS = (int)(((double)Video_PTS/90.0)+0.5); 

					bFoundVideoPTS = true;
					break;
				}
				else
				{
					CurrentBfr = ( readbuf[i+7] << 24 ) |
								 ( readbuf[i+8] << 16 ) |
								 ( readbuf[i+9] << 8  ) |
								 ( readbuf[i+10] );
					BitsLeft   = 32;
					int PTS_DTS_Flags = Get_Bits(2);
					if ( PTS_DTS_Flags >= 2 )
					{
						CurrentBfr = ( readbuf[i+9] << 24 ) |
									 ( readbuf[i+10] << 16 ) |
									 ( readbuf[i+11] << 8  ) |
									 ( readbuf[i+12] );

						BitsLeft   = 32;
						int code = Get_Bits(4);
						
						//BitsLeft   -= 4;
						
						__int64 PTS_32, PTS_29, PTS_14;
						PTS_32 = Get_Bits(3);
						BitsLeft--;
						PTS_29 = Get_Bits(15);
						BitsLeft--;
						CurrentBfr = ( readbuf[i+12] << 24 ) |
									 ( readbuf[i+13] << 16 ) |
									 ( readbuf[i+14] << 8  ) |
									 ( readbuf[i+15] );
						BitsLeft   = 32;
						PTS_14 = Get_Bits(15);
						Video_PTS = PTS_32 << 30; 
						Video_PTS |= ( PTS_29 << 15 ); 
						Video_PTS |= PTS_14; 
						Video_PTS = (int)(((double)Video_PTS/90.0)+0.5); 

						_lseeki64(in, -(PTS_READBUF-i), SEEK_CUR);
						DWORD startcode;
						while ( read(in, &startcode, 4) == 4 )
						{
							if ( startcode == 0x00010000 )
							{
								read(in, &startcode, 4);
								CurrentBfr = SWAP32(startcode);
								BitsLeft = 32;
								int temp_ref = Get_Bits(10);
								int type     = Get_Bits(3);
								// 1 = I 2 = P 3 = B
							//	printf("Video PTS: %I64d ", Video_PTS);
							//	printf("temp_ref: %d %d\n", temp_ref, type);
								if ( type == 1 ) 
									bFoundVideoPTS = true;
								break;
							}
							_lseeki64(in, -3, SEEK_CUR);
						}

						// now search for
					//	bFoundVideoPTS = true;
						break;
					}
				}
			}
		}


		if ( maxtoread >= PROPERTIES_BUFFER )
			break;

		if ( bFoundVideoPTS )
			break;
	}

	if ( maxtoread >= PROPERTIES_BUFFER )
		return false;

	// reset
	_lseeki64(in, nSeekTo+maxtoread, SEEK_SET);
	bFoundVideoPTS = false;
	maxtoread = 0;

	DWORD nAudioStream = stream << 24 |
						 01		<< 16;
	
	j = 0;
	printf("\n");

	// now audio
	while ( read(in, readbuf, PTS_READBUF) == PTS_READBUF )
	{
		maxtoread += PTS_READBUF;

		for ( int i = 0; i != PTS_READBUF-15; i++ )
		{
			if ( *((DWORD*)&readbuf[i]) == nAudioStream )
			{
				if ( mpeg1 )
				{
					i+=6;
					while ( readbuf[i] & 0x80 )
						i++;
					i+=2;

					CurrentBfr = ( readbuf[i] << 24 ) |
								 ( readbuf[i+1] << 16 ) |
								 ( readbuf[i+2] << 8  ) |
								 ( readbuf[i+3] );
					BitsLeft   = 32;
					BitsLeft   -= 4;
					__int64 PTS_32, PTS_29, PTS_14;
					PTS_32 = Get_Bits(3);
					BitsLeft--;
					PTS_29 = Get_Bits(15);
					BitsLeft--;
					CurrentBfr = ( readbuf[i+3] << 24 ) |
								 ( readbuf[i+4] << 16 ) |
								 ( readbuf[i+5] << 8  ) |
								 ( readbuf[i+6] );
					BitsLeft   = 32;
					PTS_14 = Get_Bits(15);
					Audio_PTS = PTS_32 << 30; 
					Audio_PTS |= ( PTS_29 << 15 ); 
					Audio_PTS |= PTS_14; 
					Audio_PTS = (int)(((double)Audio_PTS/90.0)+0.5);

					bFoundVideoPTS = true;
					break;
				}
				else
				{
					CurrentBfr = ( readbuf[i+7] << 24 ) |
								 ( readbuf[i+8] << 16 ) |
								 ( readbuf[i+9] << 8  ) |
								 ( readbuf[i+10] );
					BitsLeft   = 32;
					int PTS_DTS_Flags = Get_Bits(2);
					if ( PTS_DTS_Flags >= 2 )
					{
						CurrentBfr = ( readbuf[i+9] << 24 ) |
									 ( readbuf[i+10] << 16 ) |
									 ( readbuf[i+11] << 8  ) |
									 ( readbuf[i+12] );

						BitsLeft   = 32;
						int code = Get_Bits(4);
						
						__int64 PTS_32, PTS_29, PTS_14;

						PTS_32 = Get_Bits(3);
						BitsLeft--;
						PTS_29 = Get_Bits(15);
						BitsLeft--;
						CurrentBfr = ( readbuf[i+12] << 24 ) |
									 ( readbuf[i+13] << 16 ) |
									 ( readbuf[i+14] << 8  ) |
									 ( readbuf[i+15] );
						BitsLeft   = 32;
						PTS_14 = Get_Bits(15);
						Audio_PTS = PTS_32 << 30; 
						Audio_PTS |= ( PTS_29 << 15 ); 
						Audio_PTS |= PTS_14; 
						Audio_PTS = (int)(((double)Audio_PTS/90.0)+0.5); 

						printf("Audio PTS: %I64d\n", Audio_PTS);
						
						bFoundVideoPTS = true;
						break;
					}
				}
			}
		}


		if ( maxtoread >= PROPERTIES_BUFFER )
			break;

		if ( bFoundVideoPTS )
			break;
	}

	if ( maxtoread >= PROPERTIES_BUFFER )
		return false;

	*delay = (int)(Audio_PTS - Video_PTS);

	close(in);
	return true;
}

unsigned int CFileProperties::Get_Bits(unsigned int N)
{
		int Val = (CurrentBfr << (32 - BitsLeft)) >> (32 - N);
		BitsLeft -= N;
		return Val;
}

void CFileProperties::ResetIter()
{
	m_Iter = m_Streams.begin();
}

bool CFileProperties::GetNextStream(CStreamInfo *pStreamInfo)
{
	bool bRet = false;

	if ( m_Iter != m_Streams.end() )
	{
		if ( pStreamInfo )
		{
			*pStreamInfo = *m_Iter;
			m_Iter++;
			bRet = true;
		}
	}

	return bRet;
}

bool CFileProperties::GetStream(int index, CStreamInfo *pStreamInfo)
{
	bool bRet = false;

	list<CStreamInfo>::iterator Iter = m_Streams.begin();

	int nCount = 0;
	while ( Iter != m_Streams.end() )
	{
		if ( pStreamInfo )
		{
			if ( index == nCount )
			{
				*pStreamInfo = *Iter;
				bRet = true;
			}
		}

		nCount++;
		Iter++;
	}

	return bRet;
}

int	CFileProperties::GetListSize()
{
	return m_Streams.size();
}
