#pragma once

#include "stdafx.h"
#include "Demux.h"
#include "PMSParser.h"
#include "PATParser.h"
#include "StreamInfo.h"

#include <list>

using namespace std;

#define PROPERTIES_BUFFER (4*1024*1024)
#define PTS_READBUF 2048
#define SWAP32(x) ((x << 24) | ((x & 0xff00) << 8) | ((x & 0xff0000) >> 8) | (x >> 24))

class CFileProperties
{
public:
	bool			GetInfoFromFile(LPCSTR szFileName);
	bool			GetAudioDelay(LPCSTR szPath, __int64 nSeekTo, int *delay, int stream, int substream = 0);

	void			ResetIter();
	bool			GetNextStream(CStreamInfo *pStreamInfo);
	bool			GetStream(int index, CStreamInfo *pStreamInfo);
	int				GetListSize();
	int				GetFileType()	{ return nFileType; }

private:
	unsigned int	Get_Bits(unsigned int N);
	DWORD			CurrentBfr, BitsLeft;
	int				nFileType;

	list<CStreamInfo> m_Streams;
	list<CStreamInfo>::iterator m_Iter;
};

