#include "IFOEditAutomate.h"

void SetLBSel(HWND hParent, int nID, int nSel)
{
	::SendDlgItemMessage(hParent, nID, LB_SETCURSEL, nSel, 0);
	Sleep(IFOEDITDELAY);

	// Send update to box!
	::SendMessage(hParent, WM_COMMAND, MAKELONG(nID, LBN_SELCHANGE), (long)::GetDlgItem(hParent, nID));
	Sleep(IFOEDITDELAY);
}

void SetCBSel(HWND hParent, int nID, int nSel)
{
	::SendDlgItemMessage(hParent, nID, CB_SETCURSEL, nSel, 0);
	Sleep(IFOEDITDELAY);

	// Send update to box!
	::SendMessage(hParent, WM_COMMAND, MAKELONG(nID, CBN_SELCHANGE), (long)::GetDlgItem(hParent, nID));
	Sleep(IFOEDITDELAY);
}

HWND WaitAndFindWindow(HWND hParent, HWND hChild, LPCTSTR szClass, LPCTSTR szWindow)
{
	HWND hRet = NULL;
	while ( (hRet = FindWindowEx(hParent, hChild, szClass, szWindow)) == 0 )
	{
		Sleep(0);
	}
	Sleep(IFOEDITDELAY);
	return hRet;
}

HWND FindDialogOwnedBy(HWND hOwner)
{
	HWND hOpenDlg;
    bool bContinue = true;

	while ( bContinue )
	{
		hOpenDlg = NULL;

		while ( true )
		{
			Sleep(IFOEDITDELAY);
			hOpenDlg = FindWindowEx(NULL, hOpenDlg, "#32770", NULL);
			if ( !hOpenDlg )
				break;
			
			Sleep(IFOEDITDELAY);
			HWND hOwnedBy = ::GetWindow(hOpenDlg, GW_OWNER);
			
			if ( hOwner ==  hOwnedBy)
			{
				bContinue = false;
				break;
			}
		}

		Sleep(IFOEDITDELAY);
	}

	return hOpenDlg;
}

void AddFileToOpenDlg(HWND hOpenDlg, CString csFile)
{
	Sleep(IFOEDITDELAY);
	HWND hAddText	 = WaitAndFindWindow(hOpenDlg, NULL, "Edit", NULL);
	HWND hOpenButton = WaitAndFindWindow(hOpenDlg, NULL, "Button", NULL); // Will be the readonly button
	hOpenButton = WaitAndFindWindow(hOpenDlg, hOpenButton, "Button", NULL);
	
	Sleep(120);

	// Loop to make sure it gets the text, rather than setting it then the system reseting it
	while ( true )
	{
		char szText[400];
		::SendMessage(hAddText, WM_SETTEXT, 0, (long)(LPCSTR)csFile);
		::SendMessage(hAddText, WM_GETTEXT, 400, (long)(LPSTR)szText);
		if ( szText == csFile )
			break;
	}
	
	Sleep(IFOEDITDELAY);
	::SendMessage(hOpenButton, WM_LBUTTONDOWN, 0, 0);
	::SendMessage(hOpenButton, WM_LBUTTONUP, 0, 0);

	Sleep(IFOEDITDELAY);
	// Code to check window has gone
	while ( ::GetParent(hOpenButton) )
		Sleep(0);

}

void AddFile(HWND hParentOfOpen, int nAddButton, CString csFile)
{
	::PostMessage(hParentOfOpen, WM_COMMAND, nAddButton, 0);
	Sleep(IFOEDITDELAY);
	HWND hOpenDlg = FindDialogOwnedBy(hParentOfOpen);
	Sleep(IFOEDITDELAY);
	AddFileToOpenDlg(hOpenDlg, csFile);
	Sleep(IFOEDITDELAY);
}
