// IFOModeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rejig.h"
#include "IFOModeDlg.h"
#include "dprintf.h"
#include "Sub2Sup.h"
#include "VStripControl.h"
#include "OpenDiskDlg.h"
#include "MPEGReader.h"
#include "RequantFunctions.h"
#include "IFOEditAutomate.h"
#include "AuthorDVDDlg.h"
#include <algorithm>

#ifdef USE_DEBUG_NEW
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

#define REENCODE_VIDEO					0
#define DEMUXAND2PASSENCODE_VIDEO		1
#define DEMUX_VIDEO						2

/////////////////////////////////////////////////////////////////////////////
// CIFOModeDlg dialog


CIFOModeDlg::CIFOModeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIFOModeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIFOModeDlg)
	m_fPercentage = 70.0;
	m_ReEncodeVideo = 0;
	m_csDirectory = _T("");
	m_ConvertSub2Sup = TRUE;
	m_CorrectAC3Delay = TRUE;
	m_TotalOutputSize = 4400.0;
	m_bAuthor = FALSE;
	//}}AFX_DATA_INIT

	m_hStop = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_pImageList = NULL;
	m_nLastChapter = LB_ERR;
	m_hVStripReader = NULL;
}


void CIFOModeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIFOModeDlg)
	DDX_Control(pDX, IDC_CHAPCHECKEXPORT, m_ButtonChapExport);
	DDX_Control(pDX, IDC_DIRECTORY, m_EditDirectory);
	DDX_Control(pDX, IDC_REENCODEVIDEO, m_RadioReEncode);
	DDX_Control(pDX, IDC_CORRECTAC3DELAY, m_ButtonCorrectAC3);
	DDX_Control(pDX, IDC_CONVERTSUB2SUP, m_ButtonConvertSub);
	DDX_Control(pDX, IDC_BROWSEDIR, m_ButtonBrowseDir);
	DDX_Control(pDX, IDC_CLEAR, m_ButtonClear);
	DDX_Control(pDX, IDC_DEL, m_ButtonDel);
	DDX_Control(pDX, IDC_STREAMCHECKNONE, m_ButtonStreamCheckNone);
	DDX_Control(pDX, IDC_STREAMCHECKALL, m_ButtonStreamCheckAll);
	DDX_Control(pDX, IDC_CHAPCHECKNONE, m_ButtonChapCheckNone);
	DDX_Control(pDX, IDC_CHAPCHECKALL, m_ButtonChapCheckAll);
	DDX_Control(pDX, IDC_ADD, m_ButtonAdd);
	DDX_Control(pDX, IDC_CELLCHECKNONE, m_ButtonCellCheckNone);
	DDX_Control(pDX, IDC_CELLCHECKALL, m_ButtonCellCheckAll);
	DDX_Control(pDX, IDC_OPENDISK, m_ButtonOpenDisk);
	DDX_Control(pDX, IDC_CELLS, m_lstCells);
	DDX_Control(pDX, IDC_CHAPTERS, m_lstChapters);
	DDX_Control(pDX, IDC_DEMUX, m_DemuxButton);
	DDX_Control(pDX, IDC_VTSPGCTREE, m_VTSTree);
	DDX_Control(pDX, IDC_PERCENTAGE, m_PercentageEdit);
	DDX_Control(pDX, IDC_RECOMPRESS, m_ReCompress);
	DDX_Control(pDX, IDC_PROGRESS, m_ProgressBar);
	DDX_Control(pDX, IDC_STREAMLIST, m_lstStream);
	DDX_Text(pDX, IDC_PERCENTAGE, m_fPercentage);
	DDV_MinMaxDouble(pDX, m_fPercentage, 1., 100.);
	DDX_Radio(pDX, IDC_REENCODEVIDEO, m_ReEncodeVideo);
	DDX_Text(pDX, IDC_DIRECTORY, m_csDirectory);
	DDX_Check(pDX, IDC_CONVERTSUB2SUP, m_ConvertSub2Sup);
	DDX_Check(pDX, IDC_CORRECTAC3DELAY, m_CorrectAC3Delay);
	DDX_Text(pDX, IDC_TOTALSIZE, m_TotalOutputSize);
	DDX_Check(pDX, IDC_AUTHOR, m_bAuthor);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIFOModeDlg, CDialog)
	//{{AFX_MSG_MAP(CIFOModeDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_DEMUX, OnDemux)
	ON_LBN_SELCHANGE(IDC_STREAMLIST, OnSelChangeStreamList)
	ON_BN_CLICKED(IDC_RECOMPRESS, OnReCompress)
	ON_NOTIFY(TVN_SELCHANGED, IDC_VTSPGCTREE, OnSelChangedVTSTree)
	ON_LBN_SELCHANGE(IDC_CHAPTERS, OnSelChangeChapters)
	ON_BN_CLICKED(IDC_CHAPCHECKALL, OnChapCheckAll)
	ON_BN_CLICKED(IDC_CHAPCHECKNONE, OnChapCheckNone)
	ON_BN_CLICKED(IDC_CELLCHECKALL, OnCellCheckAll)
	ON_BN_CLICKED(IDC_CELLCHECKNONE, OnCellCheckNone)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	ON_BN_CLICKED(IDC_STREAMCHECKALL, OnStreamCheckAll)
	ON_BN_CLICKED(IDC_STREAMCHECKNONE, OnStreamCheckNone)
	ON_BN_CLICKED(IDOK, OnProcess)
	ON_BN_CLICKED(IDC_BROWSEDIR, OnBrowseDir)
	ON_BN_CLICKED(IDC_STOPPROCESS, OnStopProcess)
	ON_BN_CLICKED(IDC_OPENDISK, OnOpenDisk)
	ON_BN_CLICKED(IDC_CHAPCHECKEXPORT, OnChapCheckExport)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CIFOModeDlg::OnBrowseDir() 
{
    #ifndef BIF_NEWDIALOGSTYLE
	#define BIF_NEWDIALOGSTYLE	0x0040
	#define BIF_USENEWUI (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
	#endif

	
	if ( !UpdateData(TRUE) )
		return;

	BROWSEINFO BrowseInfo;
	char	   szPath[MAX_PATH];

	BrowseInfo.hwndOwner = this->m_hWnd;
	BrowseInfo.pidlRoot = NULL;
	BrowseInfo.pszDisplayName = szPath;
	BrowseInfo.lpszTitle = NULL;
	BrowseInfo.ulFlags = BIF_USENEWUI;
	BrowseInfo.lpfn = NULL;
	BrowseInfo.lParam = 0;
	BrowseInfo.iImage = 0;
	LPITEMIDLIST lpItemIDList = SHBrowseForFolder(&BrowseInfo);

	if ( lpItemIDList )
	{
		char szBuffer[MAX_PATH];
		if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
		{
			// At this point, szBuffer contains the path 
			// the user chose.
			if (szBuffer[0] == '\0')
			{
			   // SHGetPathFromIDList failed, or
			   // SHBrowseForFolder failed.
			   AfxMessageBox("Failed to get Directory",
				  MB_ICONSTOP|MB_OK);
			   return;
			}
		}

		m_csDirectory = szBuffer;
		UpdateData(FALSE);
	}
}

void CIFOModeDlg::OnCancel() 
{
	if ( m_hVStripReader )
	{
		SetEvent(m_hStop);
		WaitForSingleObject(m_hVStripReader, INFINITE);
	}

	if ( m_hStop )
	{
		CloseHandle(m_hStop);
		m_hStop = NULL;
	}
	CDialog::OnCancel();

	if ( m_pImageList )
	{
		m_pImageList->DeleteImageList();
		delete m_pImageList;
		m_pImageList = NULL;
	}
}

BOOL CIFOModeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	ModifyStyleEx(0,WS_EX_APPWINDOW);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CBitmap bitmap;

	m_ProgressBar.SetRange(0, 100);
	m_pImageList = new CImageList();
	m_pImageList->Create(32, 16, ILC_MASK, 2, 4);

	bitmap.LoadBitmap(IDB_CD);
	m_pImageList->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

	bitmap.LoadBitmap(IDB_FILM);
	m_pImageList->Add(&bitmap, (COLORREF)0xFFFFFF);
	bitmap.DeleteObject();

	m_VTSTree.SetImageList(m_pImageList, TVSIL_NORMAL);

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
// CIFOModeDlg message handlers

CString CIFOModeDlg::CommaSeparated(unsigned __int64 nNum)
{
	CString csNum;
	csNum.Format("%I64u", nNum);
	int nCount = 0;
	for ( int i = csNum.GetLength(); i != 0; i--, nCount++ )
	{
		if ( nCount && !(nCount % 3) )
			csNum.Insert(i, ',');
	}

	return csNum;
}

bool CIFOModeDlg::DoEvents()
{
	MSG msg;
	while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
	{
		if (msg.message == WM_QUIT)
			return false;

		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return true;
}

void CIFOModeDlg::SetActionText(CString csAction)
{
	GetDlgItem(IDC_CURRENTTEXT)->SetWindowText(csAction);
}

int CIFOModeDlg::GetNumberOfStreamsChecked(int *nFirstStream)
{
	int nCount = 0;
	int nStreams = m_lstStream.GetCount();
	for ( int i = 0; i != nStreams; i++ )
	{
		if ( m_lstStream.GetCheck(i) == 1 )
		{
			if ( !nCount && nFirstStream )
				*nFirstStream = i;
			nCount++;
		}
	}
	return nCount;
}

int CIFOModeDlg::GetCurrentPGC()
{
	int nRet = -1;
	int nCurrent = GetCurrentTitle();
	HTREEITEM hTreeItem = m_VTSTree.GetSelectedItem();

	if ( nCurrent != LB_ERR )
	{
		for ( int i = 0; i != m_Titles[nCurrent].PGCLst.size(); i++ )
		{
			if ( m_Titles[nCurrent].PGCLst[i].hTreeBranch == hTreeItem )
			{
				nRet = i;
				break;
			}
		}
	}

	return nRet;
}

int CIFOModeDlg::GetCurrentTitle()
{
	int nRet = LB_ERR;
	HTREEITEM hTreeItem = m_VTSTree.GetSelectedItem();
	
	if ( hTreeItem )
	{
		for ( int i = 0; i != m_Titles.size(); i++ )
		{
			if ( hTreeItem == m_Titles[i].hTreeParent )
				nRet = i;

			for ( int j = 0; j != m_Titles[i].PGCLst.size(); j++ )
				if ( m_Titles[i].PGCLst[j].hTreeBranch == hTreeItem )
					nRet = i;

			if ( nRet != LB_ERR )	// We have found what we are looking for
				break;
		}
	}

	return nRet;
}

void CIFOModeDlg::ReDrawAll()
{
	int i, nCurrent = GetCurrentTitle(); 
	int nCurrentPGC = GetCurrentPGC();

	m_lstStream.ResetContent();
	m_lstChapters.ResetContent();
	m_StreamListVec.clear();

	if (  nCurrent != LB_ERR && nCurrentPGC != LB_ERR )
	{
		// Output Streams
		for ( i = 0; i != m_Titles[nCurrent].StreamLst.size(); i++ )
		{
			// if the stream belongs to the PGC (is this working in VStrip ok?)
			if ( m_Titles[nCurrent].StreamLst[i].stStreamType == STREAM_M2V || m_Titles[nCurrent].StreamLst[i].PGCs.find(nCurrentPGC) != m_Titles[nCurrent].StreamLst[i].PGCs.end() )
			{
				m_StreamListVec.push_back(i);
				m_lstStream.AddString(m_Titles[nCurrent].StreamLst[i].szStreamName);
			}
		}
		
		// Select the video stream automatically
		if ( m_lstStream.GetCount() )
			m_lstStream.SetCheck(0, TRUE);
		
		// Output Chapters
		for ( i = 0; i != m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst.size(); i++ )
		{
			CString csChapter;
			csChapter.Format(" Chapter %d", m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[i].nChapterNum+1);
			m_lstChapters.AddString(csChapter);
			m_lstChapters.SetCheck(i, TRUE);
		}

		// Select the chapter list...
		if ( m_lstChapters.GetCurSel() == LB_ERR )
			m_lstChapters.SetCurSel(0);

		OnSelChangeStreamList();
		OnSelChangeChapters();
	}
}

void CIFOModeDlg::AddTitle(CString csIFOFile)
{
	// Final check for file
	if ( GetFileAttributes(csIFOFile) == -1L )
		return;

	// gotta parse the ifo, then add everything
	CTitle Title;
	AuthDrive(csIFOFile);	// Authenticate First
	if ( GetIFOInfo(csIFOFile, NULL, &Title) )
	{
		Title.csIFOFile = csIFOFile;
		Title.AutoAddVobs();

		bool bFirst = false;

		if ( !m_Titles.size() )
			bFirst = true;

		m_Titles.push_back(Title);
		
		CString csVTS, csVTSString;
		int nSlash = Title.csIFOFile.ReverseFind('\\');
		csVTS = Title.csIFOFile.Right(Title.csIFOFile.GetLength()-nSlash-1);
		int nDot = csVTS.ReverseFind('.');
		csVTS = csVTS.Left(nDot-2);
		csVTSString.Format("%s   (%s bytes)", csVTS, (LPCSTR)CommaSeparated(Title.m_nTotalFileSize));
		
		TV_INSERTSTRUCT tvTreeItem;
		tvTreeItem.hParent = NULL;
		tvTreeItem.hInsertAfter = TVI_ROOT;
		tvTreeItem.item.iImage = 0;
		tvTreeItem.item.iSelectedImage = 0;
		tvTreeItem.item.pszText = (LPSTR)(LPCSTR)csVTSString;
		tvTreeItem.item.mask = TVIF_IMAGE | TVIF_TEXT;

		(&(m_Titles.back()))->hTreeParent = m_VTSTree.InsertItem(&tvTreeItem);

		HTREEITEM tiLongestPGC = NULL;
		int nPGCTime = 0;

		for ( int i = 0; i != m_Titles.back().PGCLst.size(); i++ )
		{
			TV_INSERTSTRUCT tvTreeItem;
			tvTreeItem.hParent = m_Titles.back().hTreeParent;
			tvTreeItem.hInsertAfter = TVI_LAST;
			tvTreeItem.item.iImage = 1;
			tvTreeItem.item.iSelectedImage = 1;
			CString csPGCName;
			csPGCName.Format("PGC %d [%02u:%02u:%02u]", m_Titles.back().PGCLst[i].nPGC, m_Titles.back().PGCLst[i].tLength[0], m_Titles.back().PGCLst[i].tLength[1], m_Titles.back().PGCLst[i].tLength[2]);
			tvTreeItem.item.pszText = (LPSTR)(LPCSTR)csPGCName;//m_Titles.back().PGCLst[i].szPGCName;
			tvTreeItem.item.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT;
			m_Titles.back().PGCLst[i].hTreeBranch = m_VTSTree.InsertItem(&tvTreeItem);

			if ( m_Titles.back().PGCLst[i].GotTotalSeconds() > nPGCTime )
			{
				nPGCTime = m_Titles.back().PGCLst[i].GotTotalSeconds();
				tiLongestPGC = m_Titles.back().PGCLst[i].hTreeBranch;
			}
		}

		// if its the first Title select the biggest PGC
		m_VTSTree.Expand(m_Titles.back().hTreeParent, TVE_EXPAND);
		if ( bFirst )
		{
			if ( tiLongestPGC )
				m_VTSTree.SelectItem(tiLongestPGC);
		}

		ReDrawAll();
	}
	else
		MessageBox("Failed to parse IFO!", "IFO Parse Fail", MB_OK | MB_ICONEXCLAMATION);

}

void CIFOModeDlg::OnAdd() 
{
	CFileDialog dlg(TRUE, "ifo", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "IFO Files (*.ifo)|*.ifo|All Files (*.*)|*.*||");

	if ( dlg.DoModal() == IDOK )
	{
		AddTitle(dlg.GetPathName());
	}
}

void CIFOModeDlg::OnDel() 
{
	int nCurrent = GetCurrentTitle();
	if ( nCurrent != LB_ERR )
	{
		if ( MessageBox("Are you sure you want to remove this Title?", "Warning", MB_YESNO | MB_ICONEXCLAMATION) == IDYES )
		{
			m_Titles.erase(&m_Titles[nCurrent]);
			m_VTSTree.DeleteItem(m_Titles[nCurrent].hTreeParent);
			
			int nNewSel = nCurrent > m_Titles.size()-1 ? m_Titles.size()-1 : nCurrent;

			if ( m_Titles.size() )
			{
				m_VTSTree.Expand(m_Titles[nNewSel].hTreeParent, TVE_EXPAND);
				m_VTSTree.Select(m_Titles[nNewSel].PGCLst[0].hTreeBranch, TVGN_DROPHILITE);
			}

			ReDrawAll();
		}
	}
}

void CIFOModeDlg::OnClear() 
{
	m_VTSTree.DeleteAllItems();
	m_Titles.clear();
	m_lstChapters.ResetContent();
	m_lstCells.ResetContent();
	ReDrawAll();	
}

////////////////////////////////////////////////////////////////////////////
// DeMuxing																  //
////////////////////////////////////////////////////////////////////////////

CString CIFOModeDlg::GetLstFileName()
{
	CString csRet;
	char szTempPath[MAX_PATH];
	GetTempPath(MAX_PATH, szTempPath);
	csRet = szTempPath;
	csRet += "Temp.lst";

	FILE *fout = fopen(csRet, "wt");

	if ( fout )
	{
		vector<CString>::iterator iter = m_Titles[GetCurrentTitle()].VOBFiles.begin();
		for ( ; iter != m_Titles[GetCurrentTitle()].VOBFiles.end(); iter++ )
			fprintf(fout, "%s\n", *iter);
		fclose(fout);
	}
	else
		MessageBox("MAJOR FAILURE! CANNOT CREATE LST FILE!", "LST ERROR", MB_OK | MB_ICONEXCLAMATION);

	return csRet;
}

CString CIFOModeDlg::GetPTSFileName()
{
	CString csRet;
	char szTempPath[MAX_PATH];
	GetTempPath(MAX_PATH, szTempPath);
	csRet = szTempPath;
	csRet += "TempPTS.pts";
	return csRet;
}

int CIFOModeDlg::CreateDemuxParams(char **szParams, CString inFile, CString csIFOFile, int nPGC, int nStream, int nSubStream)
{
	int nRet = 6;

	szParams[0] = new char[20];
	strcpy(szParams[0], "VStrip.exe");
	szParams[1] = new char[inFile.GetLength()+10];
	strcpy(szParams[1], inFile);
	szParams[2] = new char[csIFOFile.GetLength()+10];
	sprintf(szParams[2], "-i%s", csIFOFile);
	szParams[3] = new char[10];
	sprintf(szParams[3], "-p%d", nPGC);
	szParams[4] = new char[10];
	strcpy(szParams[4], "-!doNUL");
	szParams[5] = new char[10];
	sprintf(szParams[5], "0x%x", nStream);

	if ( nSubStream )
	{
		szParams[6] = new char[10];
		sprintf(szParams[6], "0x%x", nSubStream);
		nRet = 7;
	}

	return nRet;
}

DWORD WINAPI CIFOModeDlg::ReaderThread(LPVOID lpParameter)
{
	ParamInfo *pParamInfo = (ParamInfo*)lpParameter;

	for ( int i = 0; i != pParamInfo->nArgc; i++ )
		dprintf("%s \n", pParamInfo->szParams[i]);

	VStrip(pParamInfo->nArgc, pParamInfo->szParams);

	return 0;
}

void CIFOModeDlg::OnDemux() 
{
	// Example
	// VStrip.exe e:\\rip\\sub\\vts_01_1.vob -!doe:\\rip\\yay.m2v 0xe0
	char *szParams[10];
	ZeroMemory(szParams, sizeof(char*)*10);

	int nCurrent = GetCurrentTitle();

	if ( nCurrent != LB_ERR )
	{
		CString csLstFile = GetLstFileName();
		
		SetUpVStripGlobals();

		int nSelected;

		if ( GetNumberOfStreamsChecked(&nSelected) )
		{
			ResetVStripGlobals();

			CStreamInfo StreamInfo = m_Titles[nCurrent].StreamLst[m_StreamListVec[nSelected]];
			CString csDefExt;
			CString csFilter;
			switch ( StreamInfo.stStreamType )
			{
			case STREAM_M2V:
				csDefExt = "m2v";
				csFilter = "MPEG-2 ES (*.m2v)|*.m2v";
				break;
			case STREAM_AC3:
				csDefExt = "ac3";
				csFilter = "AC3 (*.ac3)|*.ac3";
				break;
			case STREAM_LPCM:
				csDefExt = "lpcm";
				csFilter = "LPCM (*.pcm)|*.pcm";
				break;
			case STREAM_MPA:
				csDefExt = "mpa";
				csFilter = "MPA (*.mpa)|*.mpa";
				break;
			case STREAM_DTS:
				csDefExt = "dts";
				csFilter = "DTS (*.dts)|*.dts";
				break;
			case STREAM_SUB:
				csDefExt = "sup";
				csFilter = "SUP (*.sup)|*.sup";
				break;
			}
			csFilter += "|All Files (*.*)|*.*||";
			CFileDialog dlg(FALSE, csDefExt, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, csFilter);

			DWORD nCount = 0;

			if ( dlg.DoModal() == IDOK )
			{
				SetUpVStripGlobals();

				int nStream = StreamInfo.nStreamNo;
				int nSubStream = StreamInfo.nSubStream;
				CString csOutFile = dlg.GetPathName();
				CString csSupFile = csOutFile;

				if ( StreamInfo.stStreamType == STREAM_SUB )
				{
					PTSFile = fopen(GetPTSFileName(), "wb");
					if ( PTSFile )
						nOutputSubStream = nSubStream;

					csOutFile.Delete(csOutFile.GetLength()-1); // Just remove the last character = .su
				}

				int nArgc = CreateDemuxParams(szParams, csLstFile, m_Titles[nCurrent].csIFOFile, GetCurrentPGC(), nStream, nSubStream);

				DWORD dwThreadID;
				ParamInfo Params;
				Params.szParams = szParams;
				Params.nArgc = nArgc;

				HANDLE hReaderThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)&ReaderThread, &Params, 0, &dwThreadID);
				
				FILE *fout = fopen(csOutFile, "wb");

				BYTE buf[2048];
				bool bContinue = true;
				while ( bContinue )
				{
					// Make sure there is data
					while ( VStripMemoryBuffer.GetSize() == 0 )
					{
						if ( WaitForSingleObject(hReaderThread, 10) != WAIT_TIMEOUT )
						{
							CloseHandle(hReaderThread);
							hReaderThread = NULL;
							bContinue = false;
							break;
						}

						if ( ((nCount++) % 10)==0 )
						{
							DoEvents();
							int nPercent = (int)((((double)VStripAmountRead)/((double)m_Titles[nCurrent].m_nTotalFileSize))*100.0);
							m_ProgressBar.SetPos(nPercent);
						}
					}

					// Output
					int nRead = VStripMemoryBuffer.Read(buf, 2048);
					if ( nRead > 0 )
						fwrite(buf, 1, nRead, fout);
					else
						break;

					if ( !bContinue )
						break;

					if ( ((nCount++) % 10)==0 )
					{
						DoEvents();
						int nPercent = (int)((((double)VStripAmountRead)/((double)m_Titles[nCurrent].m_nTotalFileSize))*100.0);
						m_ProgressBar.SetPos(nPercent);
					}
				}

				// Output last chunk!
				BYTE *pLastBuffer = new BYTE[VStripMemoryBuffer.GetSize()];
				int nRead = VStripMemoryBuffer.Read(pLastBuffer, VStripMemoryBuffer.GetSize());
				if ( nRead > 0 )
					fwrite(buf, 1, nRead, fout);
				delete [] pLastBuffer;

				fclose(fout);
				if ( PTSFile )
				{
					fclose(PTSFile);
					PTSFile = NULL;
				}

				// now go from sub to sup
				if ( StreamInfo.stStreamType == STREAM_SUB )
				{
					Sub2Sup(csOutFile, GetPTSFileName(), csSupFile, true);
				}

				if ( hReaderThread )
				{
					WaitForSingleObject(hReaderThread, INFINITE);
					CloseHandle(hReaderThread);
				}

				// Free mem
				for ( int j = 0; j != nArgc; j++ )
					delete [] szParams[j];
			} // if ( domodal
		}

		FreeVStripGlobals();
	}
}

////////////////////////////////////////////////////////////////////////////
// List Changes															  //
////////////////////////////////////////////////////////////////////////////

void CIFOModeDlg::OnSelChangedVTSTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	ReDrawAll();

	*pResult = 0;
}

void CIFOModeDlg::OnSelChangeChapters() 
{
	int nChapSel = m_lstChapters.GetCurSel();
	int nCurrent = GetCurrentTitle(); 
	int nCurrentPGC = GetCurrentPGC();

	if ( m_lstChapters.GetCheck(nChapSel) == TRUE )
		m_lstCells.EnableWindow(TRUE);
	else
		m_lstCells.EnableWindow(FALSE);

	// Save the info from the Cells
	if ( m_nLastChapter != LB_ERR && nChapSel != LB_ERR && nCurrent != LB_ERR && nCurrentPGC != LB_ERR )
	{
		for ( int i = 0; i != m_lstCells.GetCount(); i++ )
		{
			(&m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[m_nLastChapter].VobCellsLst[i])->bUse = m_lstCells.GetCheck(i) == 1 ? true : false;
		}
	}

	m_lstCells.ResetContent();

	if ( nChapSel != LB_ERR && nCurrent != LB_ERR && nCurrentPGC != LB_ERR )
	{
		vector<CVobCells>::iterator iter = m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[nChapSel].VobCellsLst.begin();
		vector<CVobCells>::iterator itrEnd = m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[nChapSel].VobCellsLst.end();

		while ( iter != itrEnd )
		{
			CString csVobCell;
			csVobCell.Format(" VOB-ID: %d CELL-ID: %d", (*iter).vob_id, (*iter).cell_id);
			m_lstCells.AddString(csVobCell);
			if ( (*iter).bUse )
				m_lstCells.SetCheck(m_lstCells.GetCount()-1, 1);
			else
				m_lstCells.SetCheck(m_lstCells.GetCount()-1, 0);
			iter++;
		}
	}

	m_nLastChapter = nChapSel;
}

void CIFOModeDlg::OnSelChangeStreamList() 
{
	// Let the video stream be enabled if selected
/*	if ( GetNumberOfStreamsChecked() == 1 )
	{
		m_DemuxButton.EnableWindow(TRUE);
		if ( m_lstStream.GetCheck(0) == 1 )
		{	 
			m_ReCompress.EnableWindow(TRUE);
			m_PercentageEdit.EnableWindow(TRUE);
		}
		else
		{
			m_ReCompress.EnableWindow(FALSE);
			m_PercentageEdit.EnableWindow(FALSE);
		}
	}
	else
	{
		m_ReCompress.EnableWindow(FALSE);
		m_PercentageEdit.EnableWindow(FALSE);
		m_DemuxButton.EnableWindow(FALSE);
	}
*/
}

void CIFOModeDlg::OnChapCheckAll() 
{
	for ( int i = 0; i != m_lstChapters.GetCount(); i++ )
		m_lstChapters.SetCheck(i, TRUE);
	OnSelChangeChapters();
}

void CIFOModeDlg::OnChapCheckNone() 
{
	for ( int i = 0; i != m_lstChapters.GetCount(); i++ )
		m_lstChapters.SetCheck(i, FALSE);
	OnSelChangeChapters();
}

void CIFOModeDlg::OnCellCheckAll() 
{
	for ( int i = 0; i != m_lstCells.GetCount(); i++ )
		m_lstCells.SetCheck(i, TRUE);
}

void CIFOModeDlg::OnCellCheckNone() 
{
	for ( int i = 0; i != m_lstCells.GetCount(); i++ )
		m_lstCells.SetCheck(i, FALSE);
}

void CIFOModeDlg::OnStreamCheckAll() 
{
	for ( int i = 0; i != m_lstStream.GetCount(); i++ )
		m_lstStream.SetCheck(i, TRUE);
}

void CIFOModeDlg::OnStreamCheckNone() 
{
	for ( int i = 0; i != m_lstStream.GetCount(); i++ )
		m_lstStream.SetCheck(i, FALSE);
}

////////////////////////////////////////////////////////////////////////////
// Re-Encoding															  //
////////////////////////////////////////////////////////////////////////////


// TEST CODE
void CIFOModeDlg::OnReCompress() 
{
	if ( !UpdateData(TRUE) )
		return;

	int nCurrent = GetCurrentTitle();

	if ( nCurrent != LB_ERR )
	{
		CString csDefExt = "m2v";
		CString csFilter = "MPEG-2 ES (*.m2v)|*.m2v";
		csFilter += "|All Files (*.*)|*.*||";
		CFileDialog dlg(FALSE, csDefExt, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, csFilter);

		if ( dlg.DoModal() == IDOK )
		{
			char *szParams[10];
			ZeroMemory(szParams, sizeof(char*)*10);

			CString csLstFile = GetLstFileName();

			int nArgc = CreateDemuxParams(szParams, csLstFile, m_Titles[nCurrent].csIFOFile, GetCurrentPGC(), 0xe0, 0);
			ParamInfo Params;
			Params.nArgc = nArgc;
			Params.szParams = szParams;
			CVStripReader VStripReader(m_Titles[nCurrent].m_nTotalFileSize, &Params);

			ReEncodeOld(m_fPercentage, dlg.GetPathName(), &VStripReader, &m_ProgressBar, m_hStop, this);

			// Free mem
			for ( int j = 0; j != nArgc; j++ )
				delete [] szParams[j];
		}
	}
}

void CIFOModeDlg::SetupVStripCells()
{
	int nCurrent = GetCurrentTitle(); 
	int nCurrentPGC = GetCurrentPGC();

	VStripVobCells.clear();

	if ( nCurrent != LB_ERR && nCurrentPGC != LB_ERR )
	{
		for ( int i = 0; i != m_lstChapters.GetCount(); i++ )
		{
			if ( m_lstChapters.GetCheck(i) == TRUE )
			{
				for ( int j = 0; j != m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[i].VobCellsLst.size(); j++ )
				{
					if ( m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[i].VobCellsLst[j].bUse )
					{
						VStripVobCells.push_back(m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[i].VobCellsLst[j]);
					}
				}
			}
		}
	}
}

void CIFOModeDlg::OnTest() 
{

}

// From parse_ifo.cpp
extern double fVideoFPS;

void CIFOModeDlg::OnProcess() 
{
	if ( !UpdateData(TRUE) )
		return;

	int nCurrent = GetCurrentTitle(); 
	int nCurrentPGC = GetCurrentPGC();

	if ( nCurrent != LB_ERR && nCurrentPGC != LB_ERR )
	{
		CString csVideoOutputName;

		ButtonControl(false);

		if ( m_bAuthor )
		{
			// Force AC3 Delay and SUP Support on if using IFOEdit
			m_ConvertSub2Sup = TRUE;
			m_CorrectAC3Delay = TRUE;
		}

		SetUpVStripGlobals();

		char *szParams[50];
		ZeroMemory(szParams, sizeof(char*)*50);

		CString csLstFile = GetLstFileName();

		CString csIfo("-i"+m_Titles[nCurrent].csIFOFile);
		CString csPGC;
		csPGC.Format("-p%d", nCurrentPGC);

		szParams[0] = "VStrip.exe";
		szParams[1] = (LPSTR)(LPCSTR)csLstFile;
		szParams[2] = (LPSTR)(LPCSTR)csIfo;
		szParams[3] = (LPSTR)(LPCSTR)csPGC;
		szParams[4] = "-!doNUL";
		int nArgc = 5;

		bool bVideoStreamSelected = false;

		for ( int i = 0; i != m_lstStream.GetCount(); i++ )
		{
			if ( m_lstStream.GetCheck(i) == TRUE )
			{
				if ( m_Titles[nCurrent].StreamLst[m_StreamListVec[i]].nStreamNo == 0xe0 )
					bVideoStreamSelected = true;

				VStripStreams.push_back(m_Titles[nCurrent].StreamLst[m_StreamListVec[i]]);

				(&VStripStreams.back())->SetOutputDir(m_csDirectory);
				(&VStripStreams.back())->pParentWnd = this;
				(&VStripStreams.back())->pProgressBar = &m_ProgressBar;
				(&VStripStreams.back())->hStop = m_hStop;
				(&VStripStreams.back())->bCreateSUP = (m_ConvertSub2Sup == TRUE);
				(&VStripStreams.back())->bCorrectAC3 = (m_CorrectAC3Delay == TRUE);

				szParams[nArgc] = new char[10];
				if ( m_Titles[nCurrent].StreamLst[m_StreamListVec[i]].nSubStream )
				{
					sprintf(szParams[nArgc++], "0x%X", m_Titles[nCurrent].StreamLst[m_StreamListVec[i]].nStreamNo);
					szParams[nArgc] = new char[10];
					sprintf(szParams[nArgc++], "0x%X", m_Titles[nCurrent].StreamLst[m_StreamListVec[i]].nSubStream);
				}
				else
				{
					sprintf(szParams[nArgc++], "0x%X", m_Titles[nCurrent].StreamLst[m_StreamListVec[i]].nStreamNo);
				}
			}
		}

		SetupVStripCells();
		
		ParamInfo Params;
		Params.nArgc = nArgc;
		Params.szParams = szParams;

		dprintf("VStrip Params: \n");
		for ( i = 1; i != nArgc; i++ )
		{
			dprintf("%d. %s \n", i, szParams[i]);
		}
		
		if ( m_ReEncodeVideo == DEMUX_VIDEO || m_ReEncodeVideo == DEMUXAND2PASSENCODE_VIDEO || !bVideoStreamSelected )
			VStripDemuxVideoInstead = true;

		hVStripStop = m_hStop;
		CVStripReader VStripReader(m_Titles[nCurrent].m_nTotalFileSize, &Params, &m_ProgressBar);

		m_hVStripReader = VStripReader.GetReaderHandle();
			 
		if ( m_ReEncodeVideo == REENCODE_VIDEO && bVideoStreamSelected )
		{
			// Has to use old code
			csVideoOutputName = m_csDirectory+CString("\\MPEG_Video_0xE0_ReJig.m2v");
			CString csText;
			csText.Format("ReEncoding...(Old Algorithm: %.3f%%)", (float)m_fPercentage);
			SetActionText(csText);
			ReEncodeOld(m_fPercentage, csVideoOutputName, &VStripReader, /*&m_ProgressBar*/ NULL, m_hStop, this);
			SetActionText("");
		}
		else
		{
			// Ok, so it's set to ReEncode using a Percentage, but no video stream
			// So Force Demux instead
			if ( m_ReEncodeVideo == REENCODE_VIDEO )
				m_ReEncodeVideo = DEMUX_VIDEO;

			if ( m_ReEncodeVideo == DEMUX_VIDEO )
				SetActionText("Demuxing Streams...");
			else
				SetActionText("Demuxing Streams && Doing 1st Pass...");

			int nCount = 0;
			HANDLE hEvents[] = { VStripReader.GetReaderHandle(), m_hStop };

			while ( WaitForMultipleObjects(2, hEvents, FALSE, 100) == WAIT_TIMEOUT )
			{

				if ( !((nCount++) % 5) )
				{
					int nPercent = (int)((((double)VStripAmountRead)/((double)VStripReader.GetTotalMPEGSize()))*100.0);
					m_ProgressBar.SetPos(nPercent);
				}

				MSG msg;
				while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
				{
					if (msg.message == WM_QUIT)
						break;

					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}

			int nPercent = (int)((((double)VStripAmountRead)/((double)VStripReader.GetTotalMPEGSize()))*100.0);
			m_ProgressBar.SetPos(nPercent);

			SetActionText("");
		}

		m_hVStripReader = NULL;

		// Free mem
		for ( int j = 5; j != nArgc; j++ )
			delete [] szParams[j];

		// List of Streams for later, also do all post processing of the files (AC3 Delay etc)
		vector<CStreamInfo> StreamList;

		if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			for ( j = 0; j != VStripStreams.size(); j++ )
			{
				CStreamInfo *st = &VStripStreams[j];

				// Save the Video Output Name and make sure we have a copy
				if ( VStripStreams[j].nStreamNo == 0xe0 && csVideoOutputName == "" )
				{
					csVideoOutputName = VStripStreams[j].m_csOutputFile;
				}
				else
				{
					if ( VStripStreams[j].m_csOutputFile == CString("") )
					{
						VStripStreams[j].m_csOutputFile = csVideoOutputName;
					}
				}

				// Setting to be created will allow the process to occur in the deconstructor
				// (Don't copy to new list, just bits you need)
				if ( (&VStripStreams[j])->stStreamType == STREAM_SUB && m_ConvertSub2Sup )
					SetActionText("Converting Sub -> Sup...");

				if ( (&VStripStreams[j])->stStreamType >= STREAM_AC3  && (&VStripStreams[j])->stStreamType <= STREAM_LPCM && m_CorrectAC3Delay )
					SetActionText("Doing Audio Delay Correction...");

				(&VStripStreams[j])->DoCreation();

				SetActionText("");

				CStreamInfo newStream;
				newStream.m_csOutputFile = VStripStreams[j].m_csOutputFile;
				newStream.nLanguageID = VStripStreams[j].nLanguageID;
				newStream.stStreamType = VStripStreams[j].stStreamType;
				strcpy(newStream.szLangID, VStripStreams[j].szLangID);
				StreamList.push_back(newStream);
			}
		}
		
		// Save before reset
		unsigned __int64 VideoSizeFor2Pass	= VStripVideoDemuxedSize;
		unsigned __int64 TotalDemuxed		= VStripTotalDemuxed;
		FreeVStripGlobals();

		// Do the 2-Pass Encode
		if ( m_ReEncodeVideo == DEMUXAND2PASSENCODE_VIDEO && bVideoStreamSelected && WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			bool bOK = false;

			CMPEGReader *pMPEGReader;
			char *szOutFile = NULL;
			
			pMPEGReader = new CMPEGReader(false, 0xe0);
			pMPEGReader->ForceES();

			if ( pMPEGReader->LoadFiles(csVideoOutputName) )
			{
				szOutFile = new char[csVideoOutputName.GetLength()+50];
				strcpy(szOutFile, csVideoOutputName);

				if ( strrchr(szOutFile, '.') )
				{
					*strrchr(szOutFile, '.')=0;
					strcat(szOutFile, "_ReJig.m2v");
				
					// Do This as the main ReJig would
					unsigned __int64 nDestSize = (m_TotalOutputSize * 1024.0 * 1024.0) - TotalDemuxed;

					// Calculate new Percentage
					unsigned __int64 nOutSize = VideoSizeFor2Pass;
					double fNewPercent = (((double)nDestSize)/((double)nOutSize)) * 100.0;
					dprintf("Original M2V Size: %I64u Output Destination Size: %I64u New Percent: %f\n", nOutSize, nDestSize, (float)fNewPercent);
					OriginalM2VSize = VideoSizeFor2Pass;
					CString csText;
					csText.Format("Encoding 2Pass...(Using Percent: %.3f%%)", (float)fNewPercent);
					SetActionText(csText);

					bool bRet;

					if ( bExternUseOldEngine )
						bRet = ReEncodeOld(fNewPercent, szOutFile, pMPEGReader, &m_ProgressBar, m_hStop, this);
					else
						bRet = ReEncode(fNewPercent, szOutFile, pMPEGReader, &m_ProgressBar, m_hStop, this);

					if ( bRet )
					{
						bOK = true;
						unsigned __int64 nOutSize = ReturnOutputSize();
					}
					else
						bOK = false;

					SetActionText("");
				}

			}

			delete pMPEGReader;

			if ( bOK )
			{
				SetActionText("Renaming Original File...");
				// rename the original OutputFile (Could delete it??)
				CString csOutBak = szOutFile;
				*strrchr(szOutFile, '_')=0;
				strcat(szOutFile, "_Orig.m2v");
				SetFileAttributes(csVideoOutputName, 0);
				int nErr = rename(csVideoOutputName, szOutFile);
				csVideoOutputName = csOutBak;
				SetActionText("");
			}

			if ( szOutFile )
				delete [] szOutFile;
		}

		// AUTHORING
		if ( m_bAuthor && WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			CAuthorDVDDlg AuthorDVDDlg;
			AuthorDVDDlg.csDVDDirExt = "DVD";

			for ( i = 0; i != StreamList.size(); i++ )
			{
				CStream Stream;
				switch ( StreamList[i].stStreamType )
				{
				case STREAM_M2V:
				case STREAM_M1V:
					AuthorDVDDlg.m_VideoStream = csVideoOutputName;
					break;
				case STREAM_SUB:
					Stream.csFileName = StreamList[i].m_csOutputFile;
					Stream.nLangIdx = StreamList[i].nLanguageID;
					AuthorDVDDlg.vecSubStreams.push_back(Stream);
					break;
				default: // Assume Audio
					Stream.csFileName = StreamList[i].m_csOutputFile;
					Stream.nLangIdx = StreamList[i].nLanguageID;
					AuthorDVDDlg.vecAudioStreams.push_back(Stream);
					break;
				}
			}

			char szTemp[MAX_PATH];
			GetTempPath(MAX_PATH, szTemp);
			strcat(szTemp, "Chap.lst");
			ExportChapters(szTemp);

			AuthorDVDDlg.m_OutputDirectory = m_csDirectory;
			AuthorDVDDlg.bAutoRun = true;
			AuthorDVDDlg.bIsPal = ( fVideoFPS == 25.0 ) ? true : false;
			AuthorDVDDlg.csChapFile = szTemp;
			AuthorDVDDlg.m_csOrigIFO = m_Titles[nCurrent].csIFOFile;
			AuthorDVDDlg.m_nOrigPGC = nCurrentPGC;

			AuthorDVDDlg.DoModal();
		}

		// OLD IFOEDIT AUTHORING
		/*
		if ( m_IFOEditAuthor && WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			SetActionText("Authoring...");

			// Make a directory for the output
			CString csAuthorDir = m_csDirectory;
			csAuthorDir += "\\VIDEO_TS";
			CreateDirectory(csAuthorDir, NULL);

			// Now Load IFOEdit
			STARTUPINFO			stinfo;
			PROCESS_INFORMATION pinfo;

			ZeroMemory(&stinfo, sizeof(STARTUPINFO));
			ZeroMemory(&pinfo, sizeof(PROCESS_INFORMATION));

			stinfo.cb = sizeof(STARTUPINFO);

			if ( CreateProcess(NULL, 
						  (LPSTR)(LPCSTR)m_csIFOEdit, 
						  NULL, 
						  NULL, 
						  FALSE, 
						  0, 
						  NULL, 
						  NULL, 
						  &stinfo,
						  &pinfo) != false )
			{
				// Only allow 0.96
				HWND hMainWnd = NULL;
				HWND hAuthor = NULL;

				while ( (hMainWnd = ::FindWindow("#32770", "IfoEdit v0.96")) == NULL )
					Sleep(0);

				// Bring up the author
				Sleep(IFOEDITDELAY);
				int nRet = ::PostMessage(hMainWnd, WM_COMMAND, AUTHOR_DVD, 0);

				while ( (hAuthor = ::FindWindow("#32770", "DVD Author / Multiplex")) == NULL )
					Sleep(0);
				
				// Set the DestDir
				Sleep(IFOEDITDELAY);
				::SendDlgItemMessage(hAuthor, DEST_NAME, WM_SETTEXT, 0, (long)(LPCSTR)csAuthorDir);

				int nAudioStream = 0;
				int nSubStream = 0;
				for ( int s = 0; s != StreamList.size(); s++ )
				{
					Sleep(IFOEDITDELAY);
					CStreamInfo st = StreamList[s];
					switch ( StreamList[s].stStreamType )
					{
					case STREAM_MPA:
					case STREAM_AC3:
					case STREAM_DTS:
					case STREAM_LPCM:
						AddFile(hAuthor, AUDIO_ADD, StreamList[s].m_csOutputFile);
						SetLBSel(hAuthor, AUDIO_LST, nAudioStream++);
						SetCBSel(hAuthor, AUDIO_LANG, StreamList[s].nLanguageID+1);
						break;
					case STREAM_M1V:
					case STREAM_M2V:
						AddFile(hAuthor, VIDEO_ADD, csVideoOutputName);
						break;
					case STREAM_SUB:
						AddFile(hAuthor, SUB_ADD, StreamList[s].m_csOutputFile);
						SetLBSel(hAuthor, SUB_LST, nSubStream++);
						SetCBSel(hAuthor, SUB_LANG, StreamList[s].nLanguageID+1);
						break;
					}
				}

				// Export Chapters
				CString csChapFile = m_csDirectory;
				csChapFile += "\\ChapList.txt";
				ExportChapters(csChapFile);

				AddFile(hAuthor, CHAP_ADD, csChapFile);

				Sleep(IFOEDITDELAY);

				// Go!
				HWND hOK = ::FindWindowEx(hAuthor, NULL, "Button", "OK");
				::SendMessage(hOK, WM_LBUTTONDOWN, 0, 0);
				::SendMessage(hOK, WM_LBUTTONUP, 0, 0);

				SetActionText("Started IFOEdit Authoring...");
			}
		}*/

		ButtonControl(true);
	}	

	UpdateData(FALSE);
}

// bEnable is false when we want to get busy
void CIFOModeDlg::ButtonControl(bool bEnable)
{
	ResetEvent(m_hStop);

	m_ButtonOpenDisk.EnableWindow(bEnable);
	m_ButtonCellCheckAll.EnableWindow(bEnable);
	m_ButtonCellCheckNone.EnableWindow(bEnable);
	m_ButtonChapExport.EnableWindow(bEnable);
	m_ButtonAdd.EnableWindow(bEnable);
	m_ButtonChapCheckAll.EnableWindow(bEnable);
	m_ButtonChapCheckNone.EnableWindow(bEnable);
	m_ButtonStreamCheckAll.EnableWindow(bEnable);
	m_ButtonStreamCheckNone.EnableWindow(bEnable);
	m_ButtonDel.EnableWindow(bEnable);
	m_ButtonClear.EnableWindow(bEnable);
	m_ReCompress.EnableWindow(bEnable);
	m_ButtonBrowseDir.EnableWindow(bEnable);
	m_ButtonConvertSub.EnableWindow(bEnable);
	m_ButtonCorrectAC3.EnableWindow(bEnable);
	m_RadioReEncode.EnableWindow(bEnable);
	GetDlgItem(IDC_DEMUXVIDEO)->EnableWindow(bEnable);
	GetDlgItem(IDC_DEMUXANDENCODEVIDEO)->EnableWindow(bEnable);
	GetDlgItem(IDC_TOTALSIZE)->EnableWindow(bEnable);
	m_PercentageEdit.EnableWindow(bEnable);
	m_EditDirectory.EnableWindow(bEnable);
	m_VTSTree.EnableWindow(bEnable);
	m_lstStream.EnableWindow(bEnable);
	m_lstChapters.EnableWindow(bEnable);
	m_lstCells.EnableWindow(bEnable);
	GetDlgItem(IDOK)->EnableWindow(bEnable);
	GetDlgItem(IDC_AUTHOR)->EnableWindow(bEnable);

	// Make sure text is blank!
	SetActionText("");

	m_ProgressBar.SetPos(0);
}

void CIFOModeDlg::OnStopProcess() 
{
	SetEvent(m_hStop);	
}

void CIFOModeDlg::OnOpenDisk() 
{
	COpenDiskDlg dlg;
	if ( dlg.DoModal() == IDOK && dlg.bFoundDisc )
	{
		char szIFO[] = "X:\\VIDEO_TS\\VTS_";
		szIFO[0] = dlg.lstDriveLetter[dlg.nSelected];

		int nNum = 1;
		while ( true )
		{
			CString csIFOFile;
			csIFOFile.Format("%s%02d_0.IFO", szIFO, nNum++);

			if ( GetFileAttributes(csIFOFile) != -1L )
			{
				AddTitle(csIFOFile);
			}
			else
				break;
		}

		// Now select the longest PGC
		int nTotalSecs = 0;
		HTREEITEM tiLongestPGC = NULL;
		for ( int i = 0; i != m_Titles.size(); i++ )
		{
			for ( int j = 0; j != m_Titles[i].PGCLst.size(); j++ )
			{
				if ( m_Titles[i].PGCLst[j].GotTotalSeconds() > nTotalSecs )
				{
					nTotalSecs = m_Titles[i].PGCLst[j].GotTotalSeconds();
					tiLongestPGC = m_Titles[i].PGCLst[j].hTreeBranch;
				}
			}
		}

		if ( tiLongestPGC )
		{
			m_VTSTree.SelectItem(tiLongestPGC);
			m_VTSTree.Select(tiLongestPGC, TVGN_FIRSTVISIBLE);
		}
	}
}

// Export Chapter List
void CIFOModeDlg::ExportChapters(CString csExportFile)
{
	int nCurrent = GetCurrentTitle(); 
	int nCurrentPGC = GetCurrentPGC();

	if ( nCurrent != LB_ERR && nCurrentPGC != LB_ERR )
	{
		FILE *fout = fopen(csExportFile, "wt");
		if ( fout )
		{
			for ( int i = 0; i != m_lstChapters.GetCount(); i++ )
			{
				if ( m_lstChapters.GetCheck(i) == TRUE )
				{
					fprintf(fout, "%d\n", m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[i].nStartFrameNum);
				}
			}
			fclose(fout);
		}
	}
}

void CIFOModeDlg::OnChapCheckExport() 
{
	int nCurrent = GetCurrentTitle(); 
	int nCurrentPGC = GetCurrentPGC();

	if ( nCurrent != LB_ERR && nCurrentPGC != LB_ERR )
	{
		CFileDialog dlg(FALSE, "txt", "ChapTimes", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Chapter Times (*.txt)|*.txt|All Files (*.*)|*.*||");

		if ( dlg.DoModal() == IDOK )
		{
			ExportChapters(dlg.GetPathName());
		}
	}
}

void CIFOModeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
