#if !defined(AFX_IFOMODEDLG_H__C05A89F7_6EC6_4336_BAA0_B2C6F30B5BF5__INCLUDED_)
#define AFX_IFOMODEDLG_H__C05A89F7_6EC6_4336_BAA0_B2C6F30B5BF5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IFOModeDlg.h : header file
//
#include "stdafx.h"
#include "Title.h"
#include "VStripControl.h"
#include "AuthDrive.h"
#include "VStripReader.h"
#include <vector>

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CIFOModeDlg dialog

class CIFOModeDlg : public CDialog
{
// Construction
public:
	CIFOModeDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CIFOModeDlg)
	enum { IDD = IDD_IFOMODE_DIALOG };
	CButton	m_ButtonChapExport;
	CEdit	m_EditDirectory;
	CButton	m_RadioReEncode;
	CButton	m_ButtonCorrectAC3;
	CButton	m_ButtonConvertSub;
	CButton	m_ButtonBrowseDir;
	CButton	m_ButtonClear;
	CButton	m_ButtonDel;
	CButton	m_ButtonStreamCheckNone;
	CButton	m_ButtonStreamCheckAll;
	CButton	m_ButtonChapCheckNone;
	CButton	m_ButtonChapCheckAll;
	CButton	m_ButtonAdd;
	CButton	m_ButtonCellCheckNone;
	CButton	m_ButtonCellCheckAll;
	CButton	m_ButtonOpenDisk;
	CCheckListBox	m_lstCells;
	CCheckListBox	m_lstChapters;
	CButton	m_DemuxButton;
	CTreeCtrl	m_VTSTree;
	CEdit	m_PercentageEdit;
	CButton	m_ReCompress;
	CProgressCtrl	m_ProgressBar;
	CCheckListBox	m_lstStream;
	double	m_fPercentage;
	int		m_ReEncodeVideo;
	CString	m_csDirectory;
	BOOL	m_ConvertSub2Sup;
	BOOL	m_CorrectAC3Delay;
	double	m_TotalOutputSize;
	BOOL	m_bAuthor;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIFOModeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void	AddTitle(CString csIFOFile);
	CString CommaSeparated(unsigned __int64 nNum);
	bool	DoEvents();
	void	ReDrawAll();
	int		GetNumberOfStreamsChecked(int *nFirstStream = NULL);
	int		GetCurrentTitle(); 
	int		GetCurrentPGC(); 
	CString GetLstFileName();
	CString GetPTSFileName();
	void	SetupVStripCells();
	int		CreateDemuxParams(char **szParams, CString inFile, CString csIFOFile, int nPGC, int nStream, int nSubStream);
	void	ButtonControl(bool bEnable);
	void	ExportChapters(CString csExportFile);
	void	SetActionText(CString csAction);

	static DWORD WINAPI ReaderThread(LPVOID lpParameter);

	vector<CTitle> m_Titles;
	HANDLE		   m_hStop;
	CImageList*	   m_pImageList;
	vector<int>	   m_StreamListVec;
	int			   m_nLastChapter;
	HANDLE		   m_hVStripReader;
	CString		   m_csIFOEdit;

	HICON		   m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CIFOModeDlg)
	afx_msg void OnAdd();
	afx_msg void OnDel();
	afx_msg void OnClear();
	afx_msg void OnDemux();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelChangeStreamList();
	afx_msg void OnReCompress();
	virtual void OnCancel();
	afx_msg void OnSelChangedVTSTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelChangeChapters();
	afx_msg void OnChapCheckAll();
	afx_msg void OnChapCheckNone();
	afx_msg void OnCellCheckAll();
	afx_msg void OnCellCheckNone();
	afx_msg void OnTest();
	afx_msg void OnStreamCheckAll();
	afx_msg void OnStreamCheckNone();
	afx_msg void OnProcess();
	afx_msg void OnBrowseDir();
	afx_msg void OnStopProcess();
	afx_msg void OnOpenDisk();
	afx_msg void OnChapCheckExport();
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IFOMODEDLG_H__C05A89F7_6EC6_4336_BAA0_B2C6F30B5BF5__INCLUDED_)
