
#include "MPEGInfo.h"

CMPEGInfo::CMPEGInfo()
{
	m_nWidth = 0;
	m_nHeight = 0;
	m_fFPS = 0;
	strcpy(m_szAspectRatio, "");
}

unsigned int CMPEGInfo::Get_Bits(unsigned int N)
{
		int Val = (CurrentBfr << (32 - BitsLeft)) >> (32 - N);
		BitsLeft -= N;
		return Val;
}

bool CMPEGInfo::GetAudioDelay(char *szPath, int *delay, int stream, int substream)
{
	unsigned char readbuf[PTS_READBUF*2];

	bool mpeg1 = false;
	
	CurrentBfr = 0;
	BitsLeft = 0;

	// load file
	FILE *in = fopen(szPath, "rb");
	if ( in == NULL )
		return false;

	fread(readbuf, 1, PTS_READBUF*2, in);
	CDemux::TestStream(readbuf, PTS_READBUF*2);// NICK, &mpeg1);
//	mpeg1 = !mpeg1;
	fseek(in, 0, SEEK_SET);

	int maxtoread = 0;

	int j = 0;

	// Find video header
	bool bFoundVideoPTS = false;
	__int64 Video_PTS, Audio_PTS;
	while ( fread(readbuf, 1, PTS_READBUF, in) == PTS_READBUF )
	{
		maxtoread += PTS_READBUF;
		
		for ( int i = 0; i != PTS_READBUF-20; i++ )
		{
			if ( *((DWORD*)&readbuf[i]) == 0xE0010000 )
			{
				int PTS_DTS_Flags = 0;
				
				if ( mpeg1 )
				{
					i+=6;
					while ( readbuf[i] & 0x80 )
						i++;
					i+=2;

					CurrentBfr = ( readbuf[i] << 24 ) |
								 ( readbuf[i+1] << 16 ) |
								 ( readbuf[i+2] << 8  ) |
								 ( readbuf[i+3] );
					BitsLeft   = 32;
					PTS_DTS_Flags = Get_Bits(4);
					__int64 PTS_32, PTS_29, PTS_14;
					PTS_32 = Get_Bits(3);
					BitsLeft--;
					PTS_29 = Get_Bits(15);
					BitsLeft--;
					CurrentBfr = ( readbuf[i+3] << 24 ) |
								 ( readbuf[i+4] << 16 ) |
								 ( readbuf[i+5] << 8  ) |
								 ( readbuf[i+6] );
					BitsLeft   = 32;
					PTS_14 = Get_Bits(15);
					Video_PTS = PTS_32 << 30; 
					Video_PTS |= ( PTS_29 << 15 ); 
					Video_PTS |= PTS_14; 
					printf(" Video PTS: %I64d\n", Video_PTS);
					Video_PTS = (int)(((double)Video_PTS/90.0)+0.5); 

					bFoundVideoPTS = true;

					break;
				}
				else
				{
					int a = readbuf[i+3];
					CurrentBfr = ( readbuf[i+7] << 24 ) |
								 ( readbuf[i+8] << 16 ) |
								 ( readbuf[i+9] << 8  ) |
								 ( readbuf[i+10] );
					BitsLeft   = 32;
					PTS_DTS_Flags = Get_Bits(2);
				

					if ( PTS_DTS_Flags >= 3 )
					{
						CurrentBfr = ( readbuf[i+9] << 24 ) |
									 ( readbuf[i+10] << 16 ) |
									 ( readbuf[i+11] << 8  ) |
									 ( readbuf[i+12] );
						BitsLeft   = 32;
						int code = Get_Bits(4);
						//BitsLeft   -= 4;
						
						__int64 PTS_32, PTS_29, PTS_14;
						PTS_32 = Get_Bits(3);
						BitsLeft--;
						PTS_29 = Get_Bits(15);
						BitsLeft--;
						CurrentBfr = ( readbuf[i+12] << 24 ) |
									 ( readbuf[i+13] << 16 ) |
									 ( readbuf[i+14] << 8  ) |
									 ( readbuf[i+15] );
						BitsLeft   = 32;
						PTS_14 = Get_Bits(15);
						Video_PTS = PTS_32 << 30; 
						Video_PTS |= ( PTS_29 << 15 ); 
						Video_PTS |= PTS_14; 
						Video_PTS = (int)(((double)Video_PTS/90.0)+0.5); 

						fseek(in, -(PTS_READBUF-i), SEEK_CUR);
						DWORD startcode;
						while ( fread(&startcode, 1, 4, in) == 4 )
						{
							if ( startcode == 0x00010000 )
							{
								fread(&startcode, 1, 4, in);
								CurrentBfr = SWAP32(startcode);
								BitsLeft = 32;
								int temp_ref = Get_Bits(10);
								int type     = Get_Bits(3);
								// 1 = I 2 = P 3 = B
							//	printf("Video PTS: %I64d ", Video_PTS);
							//	printf("temp_ref: %d %d\n", temp_ref, type);
								if ( type == 1 ) 
								{
									bFoundVideoPTS = true;
								}
								break;
							}
							fseek(in, -3, SEEK_CUR);
						}

						// now search for
					//	bFoundVideoPTS = true;
						break;
					}
				}
			}
		}


		if ( maxtoread >= PROPERTIES_BUFFER )
			break;

		if ( bFoundVideoPTS )
			break;
	}

	if ( maxtoread >= PROPERTIES_BUFFER )
		return false;

	maxtoread = 0;

	// reset
	fseek(in, 0, SEEK_SET);
	bFoundVideoPTS = false;

	DWORD nAudioStream = stream << 24 |
						 01		<< 16;
	
	j = 0;
	printf("\n");

	// now audio
	while ( fread(readbuf, 1, PTS_READBUF, in) == PTS_READBUF )
	{
		maxtoread += PTS_READBUF;

		for ( int i = 0; i != PTS_READBUF-15; i++ )
		{
			if ( *((DWORD*)&readbuf[i]) == nAudioStream )
			{
				if ( mpeg1 )
				{
					i+=6;
					while ( readbuf[i] & 0x80 )
						i++;
					i+=2;

					CurrentBfr = ( readbuf[i] << 24 ) |
								 ( readbuf[i+1] << 16 ) |
								 ( readbuf[i+2] << 8  ) |
								 ( readbuf[i+3] );
					BitsLeft   = 32;
					BitsLeft   -= 4;
					__int64 PTS_32, PTS_29, PTS_14;
					PTS_32 = Get_Bits(3);
					BitsLeft--;
					PTS_29 = Get_Bits(15);
					BitsLeft--;
					CurrentBfr = ( readbuf[i+3] << 24 ) |
								 ( readbuf[i+4] << 16 ) |
								 ( readbuf[i+5] << 8  ) |
								 ( readbuf[i+6] );
					BitsLeft   = 32;
					PTS_14 = Get_Bits(15);
					Audio_PTS = PTS_32 << 30; 
					Audio_PTS |= ( PTS_29 << 15 ); 
					Audio_PTS |= PTS_14; 
					printf("Audio PTS: %I64d\n", Audio_PTS);
					Audio_PTS = (int)(((double)Audio_PTS/90.0)+0.5);

					bFoundVideoPTS = true;
					break;
				}
				else
				{
					CurrentBfr = ( readbuf[i+7] << 24 ) |
								 ( readbuf[i+8] << 16 ) |
								 ( readbuf[i+9] << 8  ) |
								 ( readbuf[i+10] );
					BitsLeft   = 32;
					int PTS_DTS_Flags = Get_Bits(2);
					if ( PTS_DTS_Flags >= 2 )
					{
						CurrentBfr = ( readbuf[i+9] << 24 ) |
									 ( readbuf[i+10] << 16 ) |
									 ( readbuf[i+11] << 8  ) |
									 ( readbuf[i+12] );

						BitsLeft   = 32;
						int code = Get_Bits(4);
						
						__int64 PTS_32, PTS_29, PTS_14;

						PTS_32 = Get_Bits(3);
						BitsLeft--;
						PTS_29 = Get_Bits(15);
						BitsLeft--;
						CurrentBfr = ( readbuf[i+12] << 24 ) |
									 ( readbuf[i+13] << 16 ) |
									 ( readbuf[i+14] << 8  ) |
									 ( readbuf[i+15] );
						BitsLeft   = 32;
						PTS_14 = Get_Bits(15);
						Audio_PTS = PTS_32 << 30; 
						Audio_PTS |= ( PTS_29 << 15 ); 
						Audio_PTS |= PTS_14; 
						printf("Audio PTS: %I64d\n", Audio_PTS);
						Audio_PTS = (int)(((double)Audio_PTS/90.0)+0.5); 

						printf("Audio PTS: %I64d\n", Audio_PTS);
						
						bFoundVideoPTS = true;
						break;
					}
				}
			}
		}


		if ( maxtoread >= PROPERTIES_BUFFER )
			break;

		if ( bFoundVideoPTS )
			break;
	}

	if ( maxtoread >= PROPERTIES_BUFFER )
		return false;

	//Video_PTS = 8834832;
	*delay = (int)(Audio_PTS - Video_PTS);

	printf(" Video PTS: %I64d\n", Video_PTS);
	printf(" Audio PTS: %I64d\n", Audio_PTS);
	printf(" Audio_PTS - Video_PTS = %d\n", *delay);
	fclose(in);
	return true;
}

bool CMPEGInfo::GetMPEGInfo(const char *szPath)
{
#define READINSIZE 5000000
#define LOADIN (1024*256)

	CMultipleFiles m_Files;

	if ( !m_Files.LoadFiles(szPath) )
		return false;

	unsigned char *buffer = (unsigned char *) malloc(LOADIN);

	int readin = m_Files.Read(buffer, LOADIN);

	int horiz = 0, vert = 0 , fps = 0, AR = 0;

	for ( int i = 0; i != readin; i++ )
	{
		// Look for the sequence header:- 0 0 1 b3
		if ( buffer[i] == 0 && buffer[i+1] == 0 )
		{
			if ( buffer[i+2] == 1 && buffer[i+3] == 0xb3 )
			{
				// read in DWORD
				CurrentBfr = ( buffer[i+4] << 24 ) |
							 ( buffer[i+5] << 16 ) |
							 ( buffer[i+6] << 8  ) |
							 ( buffer[i+7] );
				BitsLeft = 32;

				horiz = Get_Bits(12);
				vert = Get_Bits(12);
				AR = Get_Bits(4); 
				fps = Get_Bits(4); 
				break;
			}
		}
	}

	// load in 10mb to find it if that didnt work
	if ( horiz == 0 )
	{
		free(buffer);
		buffer = (unsigned char *) malloc(READINSIZE*2);

		m_Files.Seek(0, SEEK_SET);
		readin = m_Files.Read(buffer, READINSIZE*2);

		for ( int i = 0; i != readin; i++ )
		{
			// Look for the sequence header:- 0 0 1 b3
			if ( buffer[i] == 0 && buffer[i+1] == 0 )
			{
				if ( buffer[i+2] == 1 && buffer[i+3] == 0xb3 )
				{
					// read in DWORD
					CurrentBfr = ( buffer[i+4] << 24 ) |
								 ( buffer[i+5] << 16 ) |
								 ( buffer[i+6] << 8  ) |
								 ( buffer[i+7] );
					BitsLeft = 32;

					horiz = Get_Bits(12);
					vert = Get_Bits(12);
					AR = Get_Bits(4); 
					fps = Get_Bits(4); 
					break;
				}
			}
		}
	}

	if ( horiz == 0 )
		dprintf("Major Read in Error! Couldn't find Sequence Header!!!!\n");

	m_fFPS		= Frame_Rates[fps];
	m_nWidth	= horiz;
	m_nHeight	= vert;

	strcpy(m_szAspectRatio, Aspect_Ratios[AR]);

	free(buffer);
	return true;
}

// Info from:- http://mpgedit.org/mpgedit/mpeg_format/mpeghdr.htm#MPEG%20HEADER
bool CMPEGInfo::ReadMPEGAudioFormat(const char *szFileName, bool bTS, int stream, int *nFrequency, int *nLayer, int *nBitrate)
{
	#define MPSIZE 500000
	bool bRet = false;

	CMPEGReader MPEGReader(bTS, stream, 0);
	
	if ( MPEGReader.LoadFiles(szFileName) )
	{
		BYTE *pBuf = new BYTE[MPSIZE];

		int nBufSize = MPEGReader.Read(pBuf, MPSIZE);

		nBufSize -= 6;

		for ( int i = 0; i != nBufSize; i++ )
		{
			if ( pBuf[i] == 0xff && (pBuf[i+1] & 0xF0) == 0xF0 )
			{
				// Got the 12 bit sync
				CurrentBfr = ( pBuf[i+1] << 24 ) |
							 ( pBuf[i+2] << 16 ) |
							 ( pBuf[i+3] << 8  ) |
							 ( pBuf[i+4] );
				BitsLeft   = 32 - 4; // -4 for the 4 that make up the sync
				
				int Int_nType  = Get_Bits(1);	// = 0 if version 2 rather than 1
				int Int_nLayer = Get_Bits(2);   // = 1 if L3, 2 if L2 and 3 if L1
				BitsLeft --;	// Skip CRC bit
				
				BitsLeft -= 4;  // Skip Bitrate for now

				int Int_nSampleRate = Get_Bits(2);

				if ( nLayer )
				{
					switch ( Int_nLayer )
					{
					case 1:
						*nLayer = 3;
						break;
					case 2:
						*nLayer = 2;
						break;
					case 3:
						*nLayer = 1;
						break;
					}
				}

				if ( nFrequency )
				{
					switch ( Int_nSampleRate )
					{
					case 0:
						*nFrequency = 44100;
						break;
					case 1:
						*nFrequency = 48000;
						break;
					case 2:
						*nFrequency = 32000;
						break;
					}

					if ( !Int_nType )
						*nFrequency /= 2;
				}

				bRet = true;
				break;
			}
		}

		delete [] pBuf;
	}

	return bRet;
}

int	CMPEGInfo::GetWidth()
{
	return m_nWidth;
}

int	CMPEGInfo::GetHeight()
{
	return m_nHeight;
}

double CMPEGInfo::GetFPS()
{
	return m_fFPS;
}

char * CMPEGInfo::GetAR()
{
	return m_szAspectRatio;
}
