#pragma once
#include "stdafx.h"
#include "MultipleFiles.h"
#include "dprintf.h"
#include "Demux.h"
#include "MPEGReader.h"

#define PROPERTIES_BUFFER (4*1024*1024)
#define PTS_READBUF 2048
#define SWAP32(x) (x << 24) | ((x & 0xff00) << 8) | ((x & 0xff0000) >> 8) | (x >> 24)
#define READINSIZE 5000000

class CMPEGInfo
{
public:
	CMPEGInfo();

	bool GetMPEGInfo(const char *szPath);
	bool GetAudioDelay(char *szPath, int *delay, int stream, int substream);

	bool ReadMPEGAudioFormat(const char *szFileName, bool bTS, int stream, int *nFrequency = NULL,  int *nLayer = NULL, int *nBitrate = NULL);

	int		GetWidth();
	int		GetHeight();
	double	GetFPS();
	char *	GetAR();

private:
	unsigned int Get_Bits(unsigned int N);
	unsigned int CurrentBfr;
	unsigned int BitsLeft;

	int m_nWidth;
	int m_nHeight;
	double m_fFPS;
	char m_szAspectRatio[20];
};

static const double Frame_Rates[] = {0,						// forbidden
									 24000.0/1001.0,		// 23.976
									 24,					// FILM
									 25,					// PAL
									 30000.0/1001.0,		// 29.97
									 30,
									 50,
									 60000.0/1001.0,		// 59.94
									 60,
									 24,					// Reserved
									 -1,					// Reserved
									 -1,					// Reserved
									 -1,					// Reserved
									 -1,					// Reserved
									 -1,					// Reserved	
									 -1 					// Reserved
									};

static const char Aspect_Ratios[][10] = {"Forbidden",
										 "Bad AR",
										 "4:3",
										 "16:9",
										 "1.21",
										 "Reserved",
										 "Reserved",
										 "Reserved",
										 "Reserved",
										 "Reserved",
										 "Reserved",
										 "Reserved",
										 "Reserved",
										 "Reserved",
										 "Reserved",
										 "Reserved"
										};


