#pragma once
#include "MultipleFiles.h"
#include "Demux.h"
#include "MemoryBuffer.h"
#include "VStripSuperReader.h"

class CMPEGReader : public CVStripSuperReader
{
public:
	CMPEGReader(bool bTS = false, int stream_or_pid = 0xe0, int sub_stream = 0);
	~CMPEGReader();

	bool			LoadFiles(CString csFileNames);
	int				Read(unsigned char *buf, int nSize);
	int				SimpleBlockRead(unsigned char **buf);
	bool			SeekAndReset(__int64 pos);
	__int64			GetTotalMPEGSize();
	__int64			Tell();

	CMultipleFiles*	GetFilesPtr();

	unsigned int		GetPTS();
	unsigned int		GetFirstPTS();
	unsigned __int64	GetBigPTS();
	unsigned __int64	GetBigFirstPTS();

	void				ForceES();
	bool				GetForceES();

private:
	CMultipleFiles *m_Files;
	CDemux		   *m_pDemux;
	CMemoryBuffer  m_DemuxedBuffer;

	CString		   m_csFileNames;
	BYTE		   *pBuffer;
	int			   m_nBufferSize;
	bool		   m_bForceES;

	int			   m_nStream;
	int			   m_nSubStream;
	bool		   m_bTS;
};
