#include "MemBlock.h"

CMemBlock::CMemBlock()
{
	m_Block		= NULL;
	m_OrigBlock = NULL;
	m_nSize		= 0;
	bAutoRemove = true;
}

CMemBlock::CMemBlock(const CMemBlock &FromBlock)
{
	m_nSize		= FromBlock.m_nSize;

	if ( FromBlock.bAutoRemove )
	{
		m_OrigBlock = new BYTE[FromBlock.m_nSize];
		memcpy(m_OrigBlock, FromBlock.m_Block, FromBlock.m_nSize);
	}
	else
		m_Block = FromBlock.m_Block;

	m_Block		= m_OrigBlock;
	bAutoRemove = FromBlock.bAutoRemove;
}


CMemBlock::~CMemBlock()
{
	if ( bAutoRemove && m_OrigBlock )
		delete [] m_OrigBlock;
}

void CMemBlock::CopyBlockIn(BYTE *block, int nSize)
{
	if ( m_Block )
		delete [] m_Block;

	m_OrigBlock = new BYTE[nSize];
	m_Block		= m_OrigBlock;

	memcpy(m_Block, block, nSize);

	m_nSize		= nSize;
	bAutoRemove = true;
}

void CMemBlock::LinkBlockIn(BYTE *block, int nSize)
{
	m_OrigBlock = block;
	m_Block		= m_OrigBlock;
	m_nSize		= nSize;
	bAutoRemove = false;
}

int CMemBlock::GetSize()
{
	return m_nSize;
}

BYTE *CMemBlock::GetBlock()
{
	return m_Block;
}

int CMemBlock::ReadMemory(BYTE *buffer, int nSize)
{
	if ( nSize > m_nSize )
		nSize = m_nSize;

	memcpy(buffer, m_Block, nSize);

	// Adjust for next read
	m_Block += nSize;
	m_nSize -= nSize;

	return nSize;
}