// MultipleFiles ver 2.0 - For handling multiple file
// MFC Version

#ifndef __MULTIPLEFILES_H__
#define __MULTIPLEFILES_H__

#include "stdafx.h"
#include <io.h>
#include <fcntl.h>
#include <stdio.h>
#include <list>
#include <vector>

using namespace std;

class CFileData
{
public:
	CString csPath;
	__int64 nFileSize;
};

class CMultipleFiles
{
public:
	CMultipleFiles();
	~CMultipleFiles();

	bool	LoadFiles(const char *szFileNames);
	bool	LoadListFile(const char *szListFile);
	bool	AddFile(const char *szPathName);

	bool	Seek(__int64 nPos, int nSeekMethod = SEEK_SET);
	int		Read(unsigned char *buf, int nSize); 
	__int64 Tell();
	void	Close();

	__int64		GetTotalSize()			{ return m_nTotalFileSize; }
	int			GetNumberOfFiles()		{ return m_Files.size(); }
	const char *GetFileName(int index)	{ return m_Files[index].csPath; }
	int			GetCurrentFile()		{ return m_nCurrentFile; }


private:
	void CleanUp();

	__int64 m_nTotalFileSize;
	int		m_hCurrentFile;
	int		m_nCurrentFile;

	vector<CFileData> m_Files;
};

#endif
