#include "PATParser.h"

CPATParser::CPATParser()
{
}

int CPATParser::GetFirstPMID(const char *szFN)
{
	FILE *fin = fopen(szFN, "rb");

	if ( !fin )
		return 0;

	unsigned char byte;
	int program = 0;
	int pmid = 0;

	// First find a sync byte
	while ( true )
	{
		fread(&byte, 1, 1, fin);
		printf("%02X ", byte);
		if ( byte == PAT_TS_SYNC_BYTE )
		{
			fseek(fin, 187, SEEK_CUR);
			fread(&byte, 1, 1, fin);
			if ( byte == PAT_TS_SYNC_BYTE )
			{
				fseek(fin, -1, SEEK_CUR);
				break;
			}
			fseek(fin, -188, SEEK_CUR);
		}
	}

	char buffer[128];

	bool bFoundPAT = true;

	while ( true )
	{
		int readin = fread(buffer, 1, 4, fin);

		if ( readin != 4 )
		{
			bFoundPAT = false;
			break;
		}

		if ( buffer[0] == PAT_TS_SYNC_BYTE )
		{
			int PID = 0;

			PID = (buffer[1] & 0x1f) << 8;
			PID |= buffer[2];

			if ( PID == PAT_PID )  
				break;
		}
		fseek(fin, 188-4, SEEK_CUR);
	}

	if ( bFoundPAT )
	{
		fread(&byte, 1, 1, fin);
		fseek(fin, byte, SEEK_CUR);
		if ( fread(buffer, 1, 8, fin) == 8 )
		{
			int sectionLength = (buffer[1] & 0x0f) << 8;
				sectionLength |= buffer[2];

				int N = (sectionLength - 5 - 4) / 4;

				for (int j=0; j<N; ++j)
				{
					fread(buffer, 1, 4, fin);
					program = (buffer[0] << 8) | buffer[1];
					pmid = ((buffer[2] & 0x1f) << 8) | buffer[3];

					break;
				}
		}
	}

	if ( fin )
		fclose(fin);

	return pmid;
}


