// ReJigDlg.h : header file
//

#if !defined(AFX_REJIGDLG_H__2BB3677C_1CE7_4BA6_A90B_5201D5271F11__INCLUDED_)
#define AFX_REJIGDLG_H__2BB3677C_1CE7_4BA6_A90B_5201D5271F11__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "FileProperties.h"
#include "MultipleFiles.h"
#include "MPEGReader.h"
#include "Job.h"
#include "AddDlg.h"
#include "IFOModeDlg.h"
#include "ReJigSplashDlg.h"
#include "VStripControl.h"
#include "AuthDrive.h"
#include "WizardOpenDlg.h"
#include "WizardStreamSelectDlg.h"
#include "WizardOutputSelectDlg.h"
#include "WizardEncodeDlg.h"
#include "AuthorDVDDlg.h"
#include "SettingsDlg.h"
#include <vector>

using namespace std;

CString DelayAC3(const char *szAC3File, double fDelay, CProgressCtrl *pProgressBar, HANDLE hStop, CDialog *pDlg);

/////////////////////////////////////////////////////////////////////////////
// CReJigDlg dialog

class CReJigDlg : public CDialog
{
// Construction
public:
	CReJigDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CReJigDlg)
	enum { IDD = IDD_REJIG_DIALOG };
	CButton	m_DelayAC3Box;
	CButton	m_IFOMode;
	CButton	m_RecompressCurrent;
	CEdit	m_OutputFile;
	CButton	m_OK;
	CButton	m_Demux;
	CButton	m_Refresh;
	CButton	m_Stop;
	CButton	m_Del;
	CButton	m_Clear;
	CButton	m_Add;
	CProgressCtrl	m_ProgressBar;
	CListBox	m_lstStreamList;
	CListBox	m_lstInputList;
	CString	m_csOutputFile;
	double	m_fCompressionFactor;
	BOOL	m_DelayAC3;
	int		m_NoOfPasses;
	double	m_OutputSizeMB;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReJigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CString FormatText(char* fmt, ...);
	bool	DoEvents();
	void	ButtonControl(bool bEnable);
	void	RedrawStreamList();
	void	Recompress(bool bAll);
	bool	SaveJob(int nJob);
	bool	WriteJob(int nJob);
	void	ReadInCCEData(LPCSTR szCCEData);
	void	ReadInREJIGData(LPCSTR szREJIGData);
	void	HorizScrollBox();
	void	AddString(CString csFile, bool bMultiple = false);
	void	SetState(int nIndex, bool bSuccess);
	void	AddFile(CString csFile, CString csOutFile, int nPasses, int nOutputSize, double fLevel);
	bool	SplashLoop();

	// Wizard Functions
	bool	RunWizard();
	void	AddTitle(CString csIFOFile);

	HICON			m_hIcon;
	int				m_PreviousJobSelection;
	char			*pszMPGFilterExt;
	CFileProperties m_FileProperties;
	HANDLE			m_hStop;
	HANDLE			m_hBusy;
	vector<CJob>	m_JobList;
	bool			m_bQuietMode;
	bool			m_bQuitApp;
	bool			m_bCloseDownAfter;
	bool			m_bAutoRun;

	// Wizard Variables
	vector<CTitle> m_Titles;
	int			   m_nLongestTitle;
	int			   m_nLongestPGC;
	int			   m_nPGCTime;
	CString		   m_csIFOName;

	// Generated message map functions
	//{{AFX_MSG(CReJigDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAdd();
	afx_msg void OnDel();
	afx_msg void OnClear();
	afx_msg int OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex);
	afx_msg void OnRefresh();
	afx_msg void OnDemux();
	virtual void OnCancel();
	afx_msg void OnStop();
	afx_msg void OnBrowse();
	afx_msg void OnRecompressAll();
	afx_msg void OnSelChangeInputlist();
	afx_msg void OnRecompressCurrent();
	afx_msg void OnQuitOut();
	afx_msg void OnIFOMode();
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REJIGDLG_H__2BB3677C_1CE7_4BA6_A90B_5201D5271F11__INCLUDED_)
