// ReJigSplashDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rejig.h"
#include "ReJigSplashDlg.h"
/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/
/////////////////////////////////////////////////////////////////////////////
// CReJigSplashDlg dialog


CReJigSplashDlg::CReJigSplashDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CReJigSplashDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CReJigSplashDlg)
	//}}AFX_DATA_INIT

	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_mousedown = true;
}


void CReJigSplashDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReJigSplashDlg)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_Cancel);
	DDX_Control(pDX, IDC_DVDAUTHOR, m_DVDAuthor);
	DDX_Control(pDX, IDC_SETTINGS, m_Settings);
	DDX_Control(pDX, IDC_IFOMODE, m_IFOMode);
	DDX_Control(pDX, IDC_WIZARDMODE, m_WizardMode);
	DDX_Control(pDX, IDC_PICTURE, m_Picture);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CReJigSplashDlg, CDialog)
	//{{AFX_MSG_MAP(CReJigSplashDlg)
	ON_WM_PAINT()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_IFOMODE, OnIFOMode)
	ON_BN_CLICKED(IDC_WIZARDMODE, OnWizardMode)
	ON_WM_CREATE()
	ON_WM_QUERYDRAGICON()
	ON_WM_NCHITTEST()
	ON_BN_CLICKED(IDC_DVDAUTHOR, OnDvdAuthor)
	ON_BN_CLICKED(IDC_SETTINGS, OnSettings)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReJigSplashDlg message handlers

BOOL CReJigSplashDlg::OnInitDialog() 
{
	CToolTipDialog::OnInitDialog();
	
	SetWindowText("ReJig v"+VERSION_NUMBER+" by Nic"); 
	ModifyStyle(WS_CAPTION,WS_SYSMENU,SWP_FRAMECHANGED);
	ModifyStyleEx(0,WS_EX_APPWINDOW);

	// Tool Tips
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDC_WIZARDMODE), "Use this Wizard for Main Movie DVD Backup Only");
	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Use this for transcoding or demuxing MPEG-2 streams");
	m_wndToolTip.AddTool(GetDlgItem(IDC_IFOMODE), "Use this for transcoding or demuxing using IFO Files");
	m_wndToolTip.AddTool(GetDlgItem(IDC_DVDAUTHOR), "Use this to combine M2V/AC3/Etc files into DVD VOBs & IFOs");
	m_wndToolTip.AddTool(GetDlgItem(IDC_SETTINGS), "Advanced Settings can be configured here. (Only change if you know what you are doing!)");
	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Use this for...Quitting ;)");

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_Picture.Load(MAKEINTRESOURCE(IDR_IDR_JPEG1),_T("IDR_JPEG"));
	
	// Make background white
	m_brush.CreateSolidBrush(RGB(120, 14, 17)); 

	m_WizardBitmap.LoadBitmap(IDB_WIZARD);
	m_IFOBitmap.LoadBitmap(IDB_IFOMODE);
	m_QuitBitmap.LoadBitmap(IDB_QUIT);
	m_SettingsBitmap.LoadBitmap(IDB_SETTINGS);
	m_FileBitmap.LoadBitmap(IDB_FILEMODE);
	m_DVDAuthorBitmap.LoadBitmap(IDB_DVDAUTHOR);

	m_WizardMode.SetBitmap(m_WizardBitmap);
	m_IFOMode.SetBitmap(m_IFOBitmap);
	m_Cancel.SetBitmap(m_QuitBitmap);
	m_Settings.SetBitmap(m_SettingsBitmap);
	m_OK.SetBitmap(m_FileBitmap);
	m_DVDAuthor.SetBitmap(m_DVDAuthorBitmap);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CReJigSplashDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting

		m_Picture.Draw();

		// Draw a black line
		CDC *pDC = GetDC();
		pDC->MoveTo(0, 76);
		pDC->LineTo(405, 76);
		
		CFont font;
		font.CreatePointFont(200, "Arial", pDC);
		LOGFONT logfont;
		font.GetLogFont(&logfont);
		font.DeleteObject();
		logfont.lfWeight = 0;//FW_BOLD;
		logfont.lfHeight = 140;
		font.CreatePointFontIndirect(&logfont, pDC);

		CFont *pOldFont = pDC->SelectObject(&font);

		pDC->SetBkMode(TRANSPARENT);
		pDC->SetTextColor(RGB(255,255,255));
		pDC->TextOut(125, 80, CString("ReJig v"+VERSION_NUMBER+" by Nic"));

		pDC->SelectObject(pOldFont);
		
		ReleaseDC(pDC);
	}
}

HBRUSH CReJigSplashDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	switch ( nCtlColor )
	{
	case CTLCOLOR_DLG:
		return m_brush;
	}
	
	return hbr;
}

void CReJigSplashDlg::OnIFOMode() 
{
	EndDialog(IDC_IFOMODE);	
}

void CReJigSplashDlg::OnWizardMode() 
{
	EndDialog(IDC_WIZARDMODE);	
}

BOOL CReJigSplashDlg::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	return CDialog::Create(IDD, pParentWnd);
}

int CReJigSplashDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}

HCURSOR CReJigSplashDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

UINT CReJigSplashDlg::OnNcHitTest(CPoint point)
{
    CRect r;
    GetClientRect(&r);
    ClientToScreen(&r);

    //Chk to see if the mouse is within 
    //the dialog client area
    if(r.PtInRect(point))
    {       
        if(m_mousedown)
        {       
            return HTCAPTION;
        }
    }

    return CDialog::OnNcHitTest(point);
}

BOOL CReJigSplashDlg::PreTranslateMessage(MSG *pMsg)
{
	if (c_bShowToolTips &&
		pMsg->message >= WM_MOUSEFIRST &&
		pMsg->message <= WM_MOUSELAST)
	{
		MSG msg;
		::CopyMemory(&msg, pMsg, sizeof(MSG));
		HWND hWndParent = ::GetParent(msg.hwnd);
		while (hWndParent && hWndParent != m_hWnd)
		{
			msg.hwnd = hWndParent;
			hWndParent = ::GetParent(hWndParent);
		}
		if (msg.hwnd)
		{
			m_wndToolTip.RelayEvent(&msg);
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CReJigSplashDlg::OnDvdAuthor() 
{
	EndDialog(IDC_DVDAUTHOR);			
}

void CReJigSplashDlg::OnSettings() 
{
	EndDialog(IDC_SETTINGS);	
}
