
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include "s_types.h"
#include "parse_ifo.h"
#include "file_io.h"
#include "../StreamInfo.h"
#include "../Chapter.h"
#include "../PGC.h"
#include "../Title.h"
#include "../VStripControl.h"
#include <vector>

using namespace std;

bool ifoParse(const char *ifo_name, const int ifo_pgc_idx, const t_ifo_flags flags, dword *num_cells, tp_vs_vobcellid *cell_ids);
bool GetIFOInfo(const char *ifo_name, CString *csInfo, CTitle *pTitle);
int VStrip(int argc, char* argv[]);

DWORD WINAPI ThreadProc(LPVOID lpParameter)
{
	// VStrip.exe e:\\rip\\sub\\vts_01_1.vob -!doe:\\rip\\yay.m2v 0xe0
	char *params[5] = { "VStrip.exe", "e:\\rip\\sub\\vts_01_1.vob", "-!doe:\\rip\\yay.m2v", "0xe0" };

	char **argv = params;
	VStrip(4, argv);

	return 0;
}

void main2()
{
	/*
	CString csIFOText;
	CTitle Title;
	GetIFOInfo("e:\\rip\\ifo.ifo", &csIFOText, &Title);*/


	SetUpVStripGlobals();

	DWORD dwThreadID;
	HANDLE hReaderThread = CreateThread(NULL, 0, ThreadProc, NULL, 0, &dwThreadID);

	FILE *fout = fopen("e:\\rip\\sub\\demux.m2v", "wb");

	BYTE buf[2048];

	bool bContinue = true;

	while ( bContinue )
	{
		// Make sure there is data
		while ( VStripMemoryBuffer.GetSize() == 0 )
		{
			if ( WaitForSingleObject(hReaderThread, 10) != WAIT_TIMEOUT )
			{
				bContinue = false;
				break;
			}
		}

		if ( !bContinue )
			break;

		// Output
		int nRead = VStripMemoryBuffer.Read(buf, 2048);
		if ( nRead > 0 )
			fwrite(buf, 1, nRead, fout);
		else
			break;
	}

	fclose(fout);
}