#pragma once
#include "stdafx.h"
#include "VStripReader.h"
#include "dprintf.h"

CVStripReader::~CVStripReader()
{
	if ( m_hReaderThread )
		CloseHandle(m_hReaderThread);
}

CVStripReader::CVStripReader(__int64 nTotalSize, ParamInfo *pParams, CProgressCtrl *pProgressBar, CDialog *pParent)
{
	DWORD dwThreadID;
	m_nTotalSize = nTotalSize;
	m_pProgressBar = pProgressBar;
	nAmountRead = 0;
	count = 0;
	m_pParent = pParent;

	m_hReaderThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)&ReaderThread, pParams, 0, &dwThreadID);
}

DWORD WINAPI CVStripReader::ReaderThread(LPVOID lpParameter)
{
	ParamInfo pParamInfo = (ParamInfo)(*(ParamInfo*)lpParameter);
	for ( int i = 0; i != pParamInfo.nArgc; i++ )
		dprintf("%s \n", pParamInfo.szParams[i]);
	VStrip(pParamInfo.nArgc, pParamInfo.szParams);
	return 0;
}

__int64	CVStripReader::Tell()
{
	return VStripAmountRead;
}

__int64	CVStripReader::GetTotalMPEGSize()
{
	return m_nTotalSize;
}

int	CVStripReader::Read(unsigned char *buf, int nSize)
{
	bool bContinue = true;

	// Make sure there is data
	while ( VStripMemoryBuffer.GetSize() == 0 )
	{
		if ( WaitForSingleObject(m_hReaderThread, 10) != WAIT_TIMEOUT )
		{
			CloseHandle(m_hReaderThread);
			m_hReaderThread = NULL;
			bContinue = false;
			break;
		}

		if ( !(count++ % 4) )
		{
			int nPercent = (int)((((double)VStripAmountRead)/m_nTotalSize)*100.0);
			m_pProgressBar->SetPos(nPercent);

			MSG msg;
			while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				if ( msg.message == WM_QUIT  )
				{
					break;
				}

				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}

	if ( !bContinue )
		return 0;

	if ( m_pProgressBar )
	{
		if ( !(count++ % 4) )
		{
			int nPercent = (int)((((double)VStripAmountRead)/m_nTotalSize)*100.0);
			m_pProgressBar->SetPos(nPercent);
		
			MSG msg;
			while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				if ( msg.message == WM_QUIT  )
				{
					break;
				}

				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}

	// Output
	return VStripMemoryBuffer.Read(buf, nSize);
}