// WizardEncodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rejig.h"
#include "WizardEncodeDlg.h"
#include "Authoring.h"
#include "VStripControl.h"
#include "VStripReader.h"
#include "Sub2Sup.h"
#include "dprintf.h"
#include "MPEGReader.h"
/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/
/////////////////////////////////////////////////////////////////////////////
// CWizardEncodeDlg dialog
bool bExternDeleteFiles = true;

void CWizardEncodeDlg::SetActionText(CString csAction)
{
	GetDlgItem(IDC_CURRENTTEXT)->SetWindowText(csAction);
}

bool CWizardEncodeDlg::DoEvents()
{
	MSG msg;
	while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
	{
		if (msg.message == WM_QUIT)
			return false;

		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return true;
}

CWizardEncodeDlg::CWizardEncodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWizardEncodeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWizardEncodeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hStop = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_hFinished = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_hVStripReader = NULL;
	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bRemoveFiles = bExternDeleteFiles;
}


void CWizardEncodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWizardEncodeDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_ProgressBar);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWizardEncodeDlg, CDialog)
	//{{AFX_MSG_MAP(CWizardEncodeDlg)
	ON_BN_CLICKED(IDC_ENCODE, OnEncode)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWizardEncodeDlg message handlers

CString CWizardEncodeDlg::GetLstFileName()
{
	CString csRet;
	char szTempPath[MAX_PATH];
	GetTempPath(MAX_PATH, szTempPath);
	csRet = szTempPath;
	csRet += "Temp.lst";

	FILE *fout = fopen(csRet, "wt");

	if ( fout )
	{
		vector<CString>::iterator iter = m_Titles[nCurrent].VOBFiles.begin();
		for ( ; iter != m_Titles[nCurrent].VOBFiles.end(); iter++ )
			fprintf(fout, "%s\n", *iter);
		fclose(fout);
	}
	else
		MessageBox("MAJOR FAILURE! CANNOT CREATE LST FILE!", "LST ERROR", MB_OK | MB_ICONEXCLAMATION);

	return csRet;
}

void CWizardEncodeDlg::OnEncode() 
{
	ResetEvent(m_hStop);

	SetUpVStripGlobals();

	CString csLstFile = GetLstFileName();

	CString csIfo("-i"+m_Titles[nCurrent].csIFOFile);
	CString csPGC;
	csPGC.Format("-p%d", nCurrentPGC);
	
	cParams.Clear();
	cParams.AddParams(csLstFile);
	cParams.AddParams(csIfo);
	cParams.AddParams(csPGC);
	cParams.AddParams("-!doNUL");

	// Set all Chapters to be use
	for ( int i = 0; i != m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst.size(); i++ )
		for ( int j = 0; j != m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[i].VobCellsLst.size(); j++ )
			VStripVobCells.push_back(m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[i].VobCellsLst[j]);

	// Set Stream Information
	char szText[300];
	m_Selected.push_back(0); // Force the first stream in, i.e. The M2V Stream!
	for ( i = 0; i != m_Selected.size(); i++ )
	{
		int Select = m_Selected[i];
		CStreamInfo *st = &m_Titles[nCurrent].StreamLst[m_Selected[i]];

		VStripStreams.push_back(m_Titles[nCurrent].StreamLst[m_Selected[i]]);

		(&VStripStreams.back())->SetOutputDir(m_csDirectory);
		(&VStripStreams.back())->pParentWnd = this;
		(&VStripStreams.back())->pProgressBar = &m_ProgressBar;
		(&VStripStreams.back())->hStop = m_hStop;
		(&VStripStreams.back())->bCreateSUP = true;		// Force
		(&VStripStreams.back())->bCorrectAC3 = true;	// Force

		if ( m_Titles[nCurrent].StreamLst[m_Selected[i]].nSubStream )
		{
			sprintf(szText, "0x%X", m_Titles[nCurrent].StreamLst[m_Selected[i]].nStreamNo);
			cParams.AddParams(szText);
			sprintf(szText, "0x%X", m_Titles[nCurrent].StreamLst[m_Selected[i]].nSubStream);
			cParams.AddParams(szText);
		}
		else
		{
			sprintf(szText, "0x%X", m_Titles[nCurrent].StreamLst[m_Selected[i]].nStreamNo);
			cParams.AddParams(szText);
		}
	}


	Params.nArgc = cParams.GetArgc();
	Params.szParams = cParams.GetArgv();
	
	VStripDemuxVideoInstead = true;
	hVStripStop = m_hStop;
	CVStripReader VStripReader(m_Titles[nCurrent].m_nTotalFileSize, &Params, &m_ProgressBar);
	
	int nCount = 0;
	HANDLE hEvents[] = { VStripReader.GetReaderHandle(), m_hStop };

	SetActionText("Demuxing...");

	while ( WaitForMultipleObjects(2, hEvents, FALSE, 100) == WAIT_TIMEOUT )
	{

		if ( !((nCount++) % 5) )
		{
			int nPercent = (int)((((double)VStripAmountRead)/((double)VStripReader.GetTotalMPEGSize()))*100.0);
			m_ProgressBar.SetPos(nPercent);
		}

		MSG msg;
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if (msg.message == WM_QUIT)
				break;

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	int nPercent = (int)((((double)VStripAmountRead)/((double)VStripReader.GetTotalMPEGSize()))*100.0);
	m_ProgressBar.SetPos(nPercent);

	m_hVStripReader = NULL;

	// DONE 
	// List of Streams for later, also do all post processing of the files (AC3 Delay etc)
	vector<CStreamInfo> StreamList;
	CString csVideoOutputName;
	bool bHaveSubs = false;

	if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
	{
		for ( int j = 0; j != VStripStreams.size(); j++ )
		{
			CStreamInfo *st = &VStripStreams[j];

			// Save the Video Output Name and make sure we have a copy
			if ( VStripStreams[j].nStreamNo == 0xe0 && csVideoOutputName == "" )
			{
				csVideoOutputName = VStripStreams[j].m_csOutputFile;
			}
			else
			{
				if ( VStripStreams[j].m_csOutputFile == CString("") )
				{
					VStripStreams[j].m_csOutputFile = csVideoOutputName;
				}
			}

			// Setting to be created will allow the process to occur in the deconstructor
			// (Don't copy to new list, just bits you need)
			if ( (&VStripStreams[j])->stStreamType == STREAM_SUB )
			{
				bHaveSubs = true;
				SetActionText("Converting Sub -> Sup...");
			}

			if ( (&VStripStreams[j])->stStreamType >= STREAM_AC3  && (&VStripStreams[j])->stStreamType <= STREAM_LPCM )
				SetActionText("Doing Audio Delay Correction...");

			(&VStripStreams[j])->DoCreation();

			SetActionText("");

			CStreamInfo newStream;
			newStream.m_csOutputFile = VStripStreams[j].m_csOutputFile;
			newStream.nLanguageID = VStripStreams[j].nLanguageID;
			newStream.stStreamType = VStripStreams[j].stStreamType;
			strcpy(newStream.szLangID, VStripStreams[j].szLangID);
			StreamList.push_back(newStream);
		}
	}

	// Now do the Second Pass
	CString csOriginalM2VFile;
	if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
	{
		unsigned __int64 VideoSizeFor2Pass	= VStripVideoDemuxedSize;
		unsigned __int64 TotalDemuxed		= VStripTotalDemuxed+36864; // Accounts for extra IFO
		FreeVStripGlobals();

		CMPEGReader *pMPEGReader;
		char *szOutFile = NULL;
		bool bOK = false;
		
		pMPEGReader = new CMPEGReader(false, 0xe0);
		pMPEGReader->ForceES();

		if ( pMPEGReader->LoadFiles(csVideoOutputName) )
		{
			szOutFile = new char[csVideoOutputName.GetLength()+50];
			strcpy(szOutFile, csVideoOutputName);

			if ( strrchr(szOutFile, '.') )
			{
				*strrchr(szOutFile, '.')=0;
				strcat(szOutFile, "_ReJig.m2v");
			
				// Do This as the main ReJig would
				unsigned __int64 TotalAssets = (((double)TotalDemuxed)*1.0269163931);
				unsigned __int64 nDestSize = (nOutputSize) - TotalAssets;
				nDestSize -= (((double)nDestSize)*.0269163931);

				// Calculate new Percentage
				unsigned __int64 nOutSize = VideoSizeFor2Pass;
				double fNewPercent = (((double)nDestSize)/((double)nOutSize)) * 100.0;

				if ( fNewPercent <= 100.0 )
				{
					dprintf("Original M2V Size: %I64u Output Destination Size: %I64u New Percent: %f\n", nOutSize, nDestSize, (float)fNewPercent);
					OriginalM2VSize = VideoSizeFor2Pass;
					CString csText;
					csText.Format("Encoding 2nd Pass...(Using Percent: %.3f%%)", (float)fNewPercent);
					SetActionText(csText);

					bool bRet;

					if ( bExternUseOldEngine )
						bRet = ReEncodeOld(fNewPercent, szOutFile, pMPEGReader, &m_ProgressBar, m_hStop, this);
					else
						bRet = ReEncode(fNewPercent, szOutFile, pMPEGReader, &m_ProgressBar, m_hStop, this);

					if ( bRet )
					{
						bOK = true;
						unsigned __int64 nOutSize = ReturnOutputSize();
					}
					else
						bOK = false;
				}

				SetActionText("");
			}

		}

		delete pMPEGReader;
	
		if ( bOK && WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			SetActionText("Renaming Original File...");
			// rename the original OutputFile (Could delete it??)
			CString csOutBak = szOutFile;
			*strrchr(szOutFile, '_')=0;
			strcat(szOutFile, "_Orig.m2v");
			csOriginalM2VFile = szOutFile;
			SetFileAttributes(csOriginalM2VFile, 0);
			int nErr = rename(csOriginalM2VFile, szOutFile);

			// Removed Orig File
			if ( m_bRemoveFiles )
			{
				SetFileAttributes(csVideoOutputName, 0);
				DeleteFile(csVideoOutputName);
			}

			csVideoOutputName = csOutBak;
			SetActionText("");
		}

		if ( szOutFile )
			delete [] szOutFile;
	}

	// MULTIPLEX
	CString csMuxOut;
	if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
	{
		csMuxOut = m_csDirectory + "\\Muxed.vob";
		CCreateParams MuxParams;
		MuxParams.AddParams("-f");
		MuxParams.AddParams("8");
		MuxParams.AddParams("-o");
		MuxParams.AddParams(csMuxOut);

		// Auto add video 
		MuxParams.AddParams(csVideoOutputName);

		// (No video)
		for ( i = 0; i != StreamList.size()-1; i++ )
		{
			if ( StreamList[i].stStreamType != STREAM_SUB )
				MuxParams.AddParams(StreamList[i].m_csOutputFile);
		}

		SetActionText("Multiplexing...");
		MPlex(MuxParams.GetArgc(), MuxParams.GetArgv(), m_ProgressBar.GetSafeHwnd(), this, m_hStop);

		// Delete Files Used
		if ( m_bRemoveFiles )
		{
			for ( i = 0; i != StreamList.size()-1; i++ )
			{
				if ( StreamList[i].stStreamType != STREAM_SUB )
				{
					SetFileAttributes(StreamList[i].m_csOutputFile, 0);
					DeleteFile(StreamList[i].m_csOutputFile);
				}
			}

			// Remove video file
			SetFileAttributes(csVideoOutputName, 0);
			DeleteFile(csVideoOutputName);
		}
	}

	// Sup Mux
	if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT && bHaveSubs )
	{
		CString csSupMuxOut = m_csDirectory + "\\SupMuxed.vob";
		CCreateParams SupMuxParams;
		SupMuxParams.AddParams(csMuxOut);
		SupMuxParams.AddParams(csSupMuxOut);

		int nSubStream = 0x20;
		for ( i = 0; i != StreamList.size(); i++ )
		{
			if ( StreamList[i].stStreamType == STREAM_SUB )
			{
				char szText[50];
				sprintf(szText, "0x%X", nSubStream);
				SupMuxParams.AddParams(StreamList[i].m_csOutputFile);
				SupMuxParams.AddParams(szText);
				nSubStream++;
			}
		}

		SetActionText("Multiplexing Subtitles...");
		SupMux(SupMuxParams.GetArgc(), SupMuxParams.GetArgv(), m_ProgressBar.GetSafeHwnd(), this, m_hStop);
		
		if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			// Delete the NonSubbed VOB && Sups
			if ( m_bRemoveFiles )
			{
				for ( i = 0; i != StreamList.size(); i++ )
				{
					if ( StreamList[i].stStreamType == STREAM_SUB )
						DeleteFile(StreamList[i].m_csOutputFile);
				}

				DeleteFile(csMuxOut);
			}
			csMuxOut = csSupMuxOut;
		}
	}

	// DVD Authoring!
	if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
	{
		CString csDVDDir = m_csDirectory + "\\DVD";
		CreateDirectory(csDVDDir, NULL);

		CCreateParams IFOMuxParams;
		IFOMuxParams.AddParams("-o");
		IFOMuxParams.AddParams(csDVDDir);

		// Do audio languages
		CString csAudioLang;
		for ( i = 0; i != StreamList.size(); i++ )
		{
			if ( StreamList[i].stStreamType != STREAM_SUB && StreamList[i].stStreamType != STREAM_M2V )
			{
				csAudioLang += StreamList[i].szLangID;
				csAudioLang += ",";
			}
		}

		if ( csAudioLang.GetLength() )
		{
			if ( csAudioLang[csAudioLang.GetLength()-1] == ',' )
				csAudioLang = csAudioLang.Left(csAudioLang.GetLength()-1);
			IFOMuxParams.AddParams("-a");
			IFOMuxParams.AddParams(csAudioLang);
		}


		// Do sub languages
		CString csSubLang;
		for ( i = 0; i != StreamList.size(); i++ )
		{
			if ( StreamList[i].stStreamType == STREAM_SUB )
			{
				csSubLang += StreamList[i].szLangID;
				csSubLang += ",";
			}
		}

		if ( csSubLang.GetLength() )
		{
			if ( csSubLang[csSubLang.GetLength()-1] == ',' )
				csSubLang = csSubLang.Left(csSubLang.GetLength()-1);
			IFOMuxParams.AddParams("-s");
			IFOMuxParams.AddParams(csSubLang);
		}
	
		// Do Chapters
		CString csChapters;
		for ( i = 0; i != m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst.size(); i++ )
		{
			csChapters += m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst[i].szChapStartTime;
			csChapters += ",";
		}

		// Remove last comma if there and add only if there is more than one chapter
		if ( csChapters.GetLength() && m_Titles[nCurrent].PGCLst[nCurrentPGC].ChapterLst.size() > 1 )
		{
			IFOMuxParams.AddParams("-c");

			if ( csChapters[csChapters.GetLength()-1] == ',' )
				csChapters = csChapters.Left(csChapters.GetLength()-1);
			dprintf("Chapters: %s  END\n", csChapters);
			IFOMuxParams.AddParams(csChapters);
		}

		// Input Vob
		IFOMuxParams.AddParams("-f");
		IFOMuxParams.AddParams(csMuxOut);

		IFOMuxParams.OutputToDebug();
		SetActionText("Create DVD Files...");
		IFOGen(IFOMuxParams.GetArgc(), IFOMuxParams.GetArgv(), m_ProgressBar.GetSafeHwnd(), this, m_hStop);

		// Remove VOB
		if ( m_bRemoveFiles )
			DeleteFile(csMuxOut);

		if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			// Now make VIDEO_TS
			IFOMuxParams.Clear();
			IFOMuxParams.AddParams("-T");
			IFOMuxParams.AddParams("-o");
			IFOMuxParams.AddParams(csDVDDir);

			SetActionText("Create DVD Structure...");
			DoEvents();
			IFOGen(IFOMuxParams.GetArgc(), IFOMuxParams.GetArgv(), m_ProgressBar.GetSafeHwnd(), this, m_hStop);
		}

		if ( WaitForSingleObject(m_hStop, 0) == WAIT_TIMEOUT )
		{
			// Now copy the Colour Look Up Table
			SetActionText("Copying Subtitle Color Structure...");
			DoEvents();
			ClutCopy(m_csIFOName, nCurrentPGC, csDVDDir+CString("\\VIDEO_TS\\VTS_01_0.ifo"), 0);
		}
	}
	

	SetEvent(m_hFinished);

	// Clean Up
	WaitForSingleObject(VStripReader.GetReaderHandle(), INFINITE);

	CloseHandle(m_hStop);
	CloseHandle(m_hFinished);
	FreeVStripGlobals();

	CDialog::OnCancel();
}

DWORD WINAPI CWizardEncodeDlg::ThreadProc(LPVOID lpParameter)
{
	CWizardEncodeDlg *This = (CWizardEncodeDlg *)lpParameter;
	Sleep(200);
	This->SendMessage(WM_COMMAND, IDC_ENCODE);
	return 0;
}

BOOL CWizardEncodeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	ModifyStyleEx(0,WS_EX_APPWINDOW);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	DWORD dwThreadID;
	CreateThread(NULL, 0, ThreadProc, this, 0, &dwThreadID);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWizardEncodeDlg::OnTest() 
{
	PostMessage(WM_COMMAND, IDC_ENCODE, NULL);	
}

void CWizardEncodeDlg::OnCancel() 
{
	SetEvent(m_hStop);
}
