// WizardOpenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rejig.h"
#include "WizardOpenDlg.h"
/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/
/////////////////////////////////////////////////////////////////////////////
// CWizardOpenDlg dialog


CWizardOpenDlg::CWizardOpenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWizardOpenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWizardOpenDlg)
	m_OpenFrom = 0;
	m_csInputDirectory = _T("");
	//}}AFX_DATA_INIT
	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	nSelected = 0;
}


void CWizardOpenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWizardOpenDlg)
	DDX_Control(pDX, IDC_DVDCOMBO, m_DrivesCombo);
	DDX_Radio(pDX, IDC_OPENFROM, m_OpenFrom);
	DDX_Text(pDX, IDC_IFOFILE, m_csInputDirectory);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWizardOpenDlg, CDialog)
	//{{AFX_MSG_MAP(CWizardOpenDlg)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWizardOpenDlg message handlers

void CWizardOpenDlg::OnOK() 
{
	nSelected = m_DrivesCombo.GetCurSel();		
	CDialog::OnOK();
}

void CWizardOpenDlg::OnBrowse() 
{
	UpdateData();

/*	CFileDialog dlg(TRUE, "ifo", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "IFO Files (*.ifo)|*.ifo|All Files (*.*)|*.*||");

	if ( dlg.DoModal() == IDOK )
	{
		m_IFOFile = dlg.GetPathName();
		m_OpenFrom = 1;
	}
*/
    #ifndef BIF_NEWDIALOGSTYLE
	#define BIF_NEWDIALOGSTYLE	0x0040
	#define BIF_USENEWUI (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
	#endif

	#ifndef BIF_NONEWFOLDERBUTTON
	#define BIF_NONEWFOLDERBUTTON 0x200
	#endif
	
	if ( !UpdateData(TRUE) )
		return;

	BROWSEINFO BrowseInfo;
	char	   szPath[MAX_PATH];

	BrowseInfo.hwndOwner = this->m_hWnd;
	BrowseInfo.pidlRoot = NULL;
	BrowseInfo.pszDisplayName = szPath;
	BrowseInfo.lpszTitle = "Please pick the directory containing the IFO && Vobs.";
	BrowseInfo.ulFlags = BIF_USENEWUI | BIF_NONEWFOLDERBUTTON;
	BrowseInfo.lpfn = NULL;
	BrowseInfo.lParam = 0;
	BrowseInfo.iImage = 0;
	LPITEMIDLIST lpItemIDList = SHBrowseForFolder(&BrowseInfo);

	if ( lpItemIDList )
	{
		char szBuffer[MAX_PATH];
		if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
		{
			// At this point, szBuffer contains the path 
			// the user chose.
			if (szBuffer[0] == '\0')
			{
			   // SHGetPathFromIDList failed, or
			   // SHBrowseForFolder failed.
			   AfxMessageBox("Failed to get Directory",
				  MB_ICONSTOP|MB_OK);
			   return;
			}
		}

		m_OpenFrom = true;
		m_csInputDirectory = szBuffer;
		UpdateData(FALSE);
	}

	UpdateData(FALSE);
}

BOOL CWizardOpenDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ModifyStyleEx(0,WS_EX_APPWINDOW);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	char video_ts[] = "x:\\VIDEO_TS\\VIDEO_TS.IFO";
	char szDrive[] = "x:\\";

	
	SetErrorMode(SEM_NOOPENFILEERRORBOX | SEM_FAILCRITICALERRORS | SEM_NOGPFAULTERRORBOX);
	for ( char drive = 'C'; drive != 'Z'+1; drive++ ) 
	{
		video_ts[0] = drive;
		szDrive[0] = drive;

		if ( GetDriveType(szDrive) == 5 )  //DRIVE_CDROM = 5  (or DVD)
		{
			if ( GetFileAttributes(video_ts) != -1L )
			{
				char szVolume[MAX_PATH];
				GetVolumeInformation(szDrive, szVolume, MAX_PATH, NULL, NULL, NULL, NULL, 0);

				CString csName = szDrive + CString("       ") + CString(szVolume);
				m_DrivesCombo.AddString(csName);
				lstDriveLetter.push_back(drive);
			}
		}
	}
	SetErrorMode(0);

	if ( m_DrivesCombo.GetCount() > 0 )
	{
		bFoundDisc = true;
		m_DrivesCombo.SetCurSel(0);
	}
	else
	{
		bFoundDisc = false;
		m_DrivesCombo.AddString("NO DVD FOUND");
		m_DrivesCombo.SetCurSel(0);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWizardOpenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
