// WizardOutputSelectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rejig.h"
#include "WizardOutputSelectDlg.h"

/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/

/////////////////////////////////////////////////////////////////////////////
// CWizardOutputSelectDlg dialog


CWizardOutputSelectDlg::CWizardOutputSelectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWizardOutputSelectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWizardOutputSelectDlg)
	m_OutputDirectory = _T("");
	//}}AFX_DATA_INIT
	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CWizardOutputSelectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWizardOutputSelectDlg)
	DDX_Control(pDX, IDC_SIZECOMBO, m_SizeCombo);
	DDX_Text(pDX, IDC_DIRECTORY, m_OutputDirectory);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWizardOutputSelectDlg, CDialog)
	//{{AFX_MSG_MAP(CWizardOutputSelectDlg)
	ON_BN_CLICKED(IDC_BROWSEDIR, OnBrowseDir)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWizardOutputSelectDlg message handlers

void CWizardOutputSelectDlg::OnBrowseDir() 
{
    #ifndef BIF_NEWDIALOGSTYLE
	#define BIF_NEWDIALOGSTYLE	0x0040
	#define BIF_USENEWUI (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
	#endif
	
	if ( !UpdateData(TRUE) )
		return;

	BROWSEINFO BrowseInfo;
	char	   szPath[MAX_PATH];

	BrowseInfo.hwndOwner = this->m_hWnd;
	BrowseInfo.pidlRoot = NULL;
	BrowseInfo.pszDisplayName = szPath;
	BrowseInfo.lpszTitle = NULL;
	BrowseInfo.ulFlags = BIF_USENEWUI;
	BrowseInfo.lpfn = NULL;
	BrowseInfo.lParam = 0;
	BrowseInfo.iImage = 0;
	LPITEMIDLIST lpItemIDList = SHBrowseForFolder(&BrowseInfo);

	if ( lpItemIDList )
	{
		char szBuffer[MAX_PATH];
		if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
		{
			// At this point, szBuffer contains the path 
			// the user chose.
			if (szBuffer[0] == '\0')
			{
			   // SHGetPathFromIDList failed, or
			   // SHBrowseForFolder failed.
			   AfxMessageBox("Failed to get Directory",
				  MB_ICONSTOP|MB_OK);
			   return;
			}
		}

		m_OutputDirectory = szBuffer;
		UpdateData(FALSE);
	}
}

BOOL CWizardOutputSelectDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	ModifyStyleEx(0,WS_EX_APPWINDOW);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_SizeCombo.AddString("4700000000 (Standard Size)");
	m_SizeCombo.AddString("4704317440 (DVDR Max)");
	m_SizeCombo.AddString("4689514240 (Safe - 10 Megs)");
	m_SizeCombo.AddString("4668542720 (Safe - 30 Megs)");
	m_SizeCombo.AddString("4647571200 (Safe - 50 Megs)");
	m_SizeCombo.AddString("4693831680 (DVDR Max - 10 Megs)");
	m_SizeCombo.AddString("4672860160 (DVDR Max - 30 Megs)");
	m_SizeCombo.AddString("4651888640 (DVDR Max - 50 Megs)");

	m_SizeCombo.SetCurSel(0);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWizardOutputSelectDlg::OnOK() 
{
	UpdateData();

	CString csSize;
	m_SizeCombo.GetWindowText(csSize);
	nOutputSize = (unsigned __int64) _atoi64(csSize);

	if ( GetFileAttributes(m_OutputDirectory) == -1L )
	{
		// If the Directory does not exist Create it
		CreateDirectory(m_OutputDirectory, NULL);
		if ( GetFileAttributes(m_OutputDirectory) == -1L )
		{
			MessageBox("Directory does not exist!", "Output Error", MB_ICONEXCLAMATION | MB_OK);
			return;
		}
	}

	CDialog::OnOK();
}

void CWizardOutputSelectDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}