// WizardStreamSelectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rejig.h"
#include "WizardStreamSelectDlg.h"
/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/
/////////////////////////////////////////////////////////////////////////////
// CWizardStreamSelectDlg dialog


CWizardStreamSelectDlg::CWizardStreamSelectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWizardStreamSelectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWizardStreamSelectDlg)
	//}}AFX_DATA_INIT
	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CWizardStreamSelectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWizardStreamSelectDlg)
	DDX_Control(pDX, IDC_STREAMLIST, m_lstStream);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWizardStreamSelectDlg, CDialog)
	//{{AFX_MSG_MAP(CWizardStreamSelectDlg)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWizardStreamSelectDlg message handlers

BOOL CWizardStreamSelectDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_hIcon	= AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	ModifyStyleEx(0,WS_EX_APPWINDOW);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	for ( int i = 0; i != m_Titles[m_nLongestTitle].StreamLst.size(); i++ )
	{
		// Dont output video stream (assume that)
		if ( m_Titles[m_nLongestTitle].StreamLst[i].stStreamType != STREAM_M2V )
		{
			// Remove the Stream Number
			CString csStreamName(m_Titles[m_nLongestTitle].StreamLst[i].szStreamName);
			csStreamName = CString(" ") + csStreamName.Right(csStreamName.GetLength()-csStreamName.Find(" - ")-3);
			m_lstStream.AddString(csStreamName);
		}
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWizardStreamSelectDlg::OnOK() 
{
	int nCount = 0;
	int nStreams = m_lstStream.GetCount();
	for ( int i = 0; i != nStreams; i++ )
	{
		if ( m_lstStream.GetCheck(i) == 1 )
		{
			m_Selected.push_back(i+1);	// +1 to make it easier for ignoring the M2V Stream
			nCount++;
		}
	}

	if ( !nCount )
	{
		MessageBox("You have not selected any streams!", "Stream Select Error", MB_ICONEXCLAMATION | MB_OK);
		return;
	}

	
	CDialog::OnOK();
}

void CWizardStreamSelectDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
