#ifndef _WAV_H
#define _WAV_H

#include <windows.h>

class CWavOutput
{
public:
	CWavOutput();

	// Functions for creating a Wav File
	int CreateWavFile(FILE *file, int channels, int samplerate, int resolution);
	int CreateWavFile(char *szFN, int channels, int samplerate, int resolution);
	void WriteWavData(void *buf, int size);
	int CloseWavFile();
	int CloseWavFile(FILE *file);

	FILE *GetFile()	{ return m_file; }

private:
	// Structures
	struct WAVEAUDIOFORMAT
	{
		unsigned short  format_tag;
		unsigned short  channels;           /* 1 = mono, 2 = stereo */
		unsigned long   samplerate;         /* typically: 44100, 32000, 22050, 11025 or 8000*/
		unsigned long   bytes_per_second;   /* SamplesPerSec * BlockAlign*/
		unsigned short  blockalign;         /* Channels * (BitsPerSample / 8)*/
		unsigned short  bits_per_sample;    /* 16 or 8 */
	};

	struct RIFF_CHUNK
	{
		char info[4];
		unsigned long length;
	};

	//Wav file creation
	FILE *m_file;
};

#endif

